﻿Imports OfficeOpenXml.FormulaParsing.Excel.Functions.Text

Public Class dlgArtikelsuche
    Private _SaveDGVColumnWidths As Boolean
    Public Property _ArticleRow As DtsDaten.ArtikelRow
    Private Sub dlgArtikelsuche_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        LoadDGVColumnwidths(DGVArtikel, My.Settings.DGVArtikelsucheSpaltenBreite)
    End Sub
    Private Sub DGVArtikel_LostFocus(sender As Object, e As EventArgs) Handles DGVArtikel.LostFocus
        _SaveDGVColumnWidths = False
    End Sub
    Private Sub DGVArtikel_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles DGVArtikel.ColumnWidthChanged
        If _SaveDGVColumnWidths Then My.Settings.DGVArtikelSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVArtikel)
    End Sub
    Private Sub DGVArtikel_Click(sender As Object, e As EventArgs) Handles DGVArtikel.Click
        _SaveDGVColumnWidths = True
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNOK.Click, BTNCancel.Click, BTNSucheLoeschen.Click
        Select Case True
            Case sender Is BTNOK : SaveArticleDataAndCloseForm()
            Case sender Is BTNCancel : CloseForm()
            Case sender Is BTNSucheLoeschen : ClearArticleSearch()
        End Select
    End Sub
    Private Sub DGVArtikel_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVArtikel.CellDoubleClick
        SaveArticleDataAndCloseForm()
    End Sub
    Private Sub SaveArticleDataAndCloseForm()
        _ArticleRow = BSArtikel.At(Of DtsDaten.ArtikelRow)
        If _ArticleRow Is Nothing Then
            ShowAutoClosingMessageBox("bitte einen Artikel auswählen.")
            Return
        End If
        Me.DialogResult = DialogResult.OK
    End Sub
    Private Sub CloseForm()
        Me.DialogResult = DialogResult.Cancel
    End Sub
    Private Sub ClearArticleSearch()
        TBSuche.Text = ""
        BSArtikel.RemoveFilter()
    End Sub
    Private Sub TBSuche_TextChanged(sender As Object, e As EventArgs) Handles TBSuche.TextChanged
        Dim SearchText = TBSuche.Text
        If SearchText.IsEmpty Then ClearArticleSearch()
        BSArtikel.Filter = "ArtNr like '*" & SearchText & "*' OR EAN like '*" & SearchText & "*' OR Name1 like '*" &
            SearchText & "*' OR Zusatz like '*" & SearchText & "*'"
    End Sub
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
        Select Case keyData
            Case = Keys.Enter : SaveArticleDataAndCloseForm()
            Case = Keys.Escape : ClearArticleSearch()
            Case = Keys.Back : RemoveLastCharFromSearchTextbox(TBSuche)
            Case Else
                If TBSuche.Focused Then Return MyBase.ProcessCmdKey(msg, keyData)
                Dim PressedKeyData = IsSearchableKeyPressed(keyData)
                If PressedKeyData.SearchableKeyPressed Then
                    TBSuche.Text &= PressedKeyData.PressedKey
                Else
                    Return MyBase.ProcessCmdKey(msg, keyData)
                End If
        End Select
    End Function
End Class