﻿
Public Class dlgKundenbestellungBearbeiten
    Private Sub dlgKundenbestellungBearbeiten_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim SelectedCustomerORder = BSKundenbstellung.At(Of DtsDaten.KundenbestellungRow)
        If SelectedCustomerORder.IsDatumKundenbestelltNull Then DTPDatumKundenBestellt.Value = System.DateTime.Now
        If SelectedCustomerORder.StueckBestellen Then
            RBST.Checked = True
        Else
            RBVE.Checked = True
        End If
    End Sub
    Private Sub ClickEvents(sender As Object, e As EventArgs) Handles BTNSave.Click, BTNArtikelSuchen.Click
        Select Case True
            Case sender Is BTNSave : ValidateUserInputAndSave()
            Case sender Is BTNArtikelSuchen : SearchArticleData()
        End Select
    End Sub
    Private Sub dlgKundenbestellungBearbeiten_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyData
            Case = Keys.Enter Or Keys.Control
                ValidateUserInputAndSave()
            Case = Keys.Enter
                SendKeys.Send("{TAB}")
                e.SuppressKeyPress = True
        End Select
    End Sub
    Private Sub ValidateUserInputAndSave()
        Dim CheckUserInput = CheckIfUserInputIsCorrect()
        If CheckUserInput.UserInputCorrect Then
            SetOrderUnit()
            Me.ValidateChildren()
            Me.DialogResult = DialogResult.OK
        Else
            ShowAutoClosingMessageBox(CheckUserInput.ErrorText)
        End If
    End Sub
    Private Function CheckIfUserInputIsCorrect() As (UserInputCorrect As Boolean, ErrorText As String)
        If TBKundenname.Text.IsEmpty Then Return (False, "kein Kundenname angegeben.")
        If TBArtNr.Text.IsEmpty Then Return (False, "keine Artikelnummer angegeben.")
        If TBArtikelName.Text.IsEmpty Then Return (False, "kein Artikelname angegeben.")
        If CBLieferant.Text.IsEmpty Then Return (False, "kein Lieferant angegeben.")
        If Not DtsDaten.Lieferant.SupplierExists(CBLieferant.Text) Then Return (False, $"Der Lieferant {CBLieferant.Text} existiert nicht.")
        If CheckForControlChars(TBArtNr) Then Return (False, "ungültige Zeichen in der Art. Nr.")
        If CheckForControlChars(TBArtikelName) Then Return (False, "ungültiges Zeichen im Artikelnamen")
        Return (True, "")
    End Function
    Private Sub SetOrderUnit()
        Dim SelectedCustomerOrder = BSKundenbstellung.At(Of DtsDaten.KundenbestellungRow)
        If RBST.Checked Then
            SelectedCustomerOrder.StueckBestellen = True
            SelectedCustomerOrder.BestelleinheitText = "St"
        Else
            SelectedCustomerOrder.StueckBestellen = False
            SelectedCustomerOrder.BestelleinheitText = "Ve"
        End If
    End Sub
    Private Sub SearchArticleData()
        Using ArticleSearch As New dlgArtikelsuche
            With ArticleSearch
                .BSMain.DataSource = DtsDaten
                If .ShowDialog = DialogResult.OK Then FillArticleData(._ArticleRow)
            End With
        End Using
    End Sub
    Private Sub FillArticleData(ArticleRow As DtsDaten.ArtikelRow)
        With ArticleRow
            CBLieferant.Text = .EXPLieferant
            TBArtNr.Text = .ArtNr
            TBArtikelName.Text = .Name1
            TBPreis.Text = .Verkaufspreis.ToString("#,##0.00")
        End With
    End Sub
End Class