﻿Public Class dlgLieferantenAuswahl
    Public Property SupplierPosition As Integer
    Public Property SupplierName As String
    Public Property SupplierID As Integer
    Private Sub dlgLieferantenAuswahl_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        FillDGVWithSupplierNames()
        AdjustDGVAndFormHeight()
        DGVLieferant.ClearSelection()
    End Sub
    Private Sub FillDGVWithSupplierNames()
        Dim Dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim ArrSupplier = Dts.Lieferant.OrderBy(Function(x) x.Name).ToArray
        Dim SupplierAmount = ArrSupplier.Length
        If SupplierAmount = -1 Then Return

        For i = 1 To Math.Ceiling(SupplierAmount / 4)
            DGVLieferant.Rows.Add()
        Next
        WriteSupplierToDGV(0, 1, CInt(SupplierAmount / 4), ArrSupplier)
        WriteSupplierToDGV(1, CInt(SupplierAmount / 4) + 1, CInt(SupplierAmount / 2), ArrSupplier)
        WriteSupplierToDGV(2, CInt(SupplierAmount / 2) + 1, CInt(SupplierAmount / 4 * 3), ArrSupplier)
        WriteSupplierToDGV(3, CInt(SupplierAmount / 4 * 3) + 1, SupplierAmount, ArrSupplier)
    End Sub
    Private Sub WriteSupplierToDGV(ColumnIndex As Integer, StartIndex As Integer, EndIndex As Integer, ArrSupplier As DtsDaten.LieferantRow())
        Dim RowIndex = -1
        For i = StartIndex To EndIndex
            RowIndex += 1
            DGVLieferant.Rows(RowIndex).Cells(ColumnIndex).Value = ArrSupplier(i - 1).Name
        Next
    End Sub
    Private Sub AdjustDGVAndFormHeight()
        Dim DGVHeight = DGVLieferant.Rows.Cast(Of DataGridViewRow).Sum(Function(x) x.Height)
        DGVLieferant.Height = DGVHeight
        Dim border As Integer = Integer.Parse(((Me.Size.Width - Me.ClientSize.Width) / 2).ToString)
        Dim header As Integer = Me.Size.Height - Me.ClientSize.Height - border
        Me.Height = DGVHeight + border + header + 80
    End Sub
    Private Sub BTNLieferantAuswaehlen_Click(sender As Object, e As EventArgs) Handles BTNLieferantAuswaehlen.Click
        ReturnSupplierBSPositionNameAndIDAndClose()
    End Sub
    Private Sub DGVLieferant_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVLieferant.CellDoubleClick
        If DGVLieferant.CurrentCell.Value IsNot Nothing Then ReturnSupplierBSPositionNameAndIDAndClose()
    End Sub
    Private Sub ReturnSupplierBSPositionNameAndIDAndClose()
        Dim SelectedSupplier = BSLieferant.At(Of DtsDaten.LieferantRow)
        SupplierPosition = BSLieferant.Position
        SupplierName = SelectedSupplier.Name
        SupplierID = SelectedSupplier.ID
        My.Settings.dlgLieferantenAuswahlPosition = Me.Location
        Me.DialogResult = DialogResult.OK
    End Sub
    Private Sub DGVLieferant_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVLieferant.CellClick
        If DGVLieferant.CurrentCell.Value IsNot Nothing Then CBLieferant.Text = DGVLieferant.CurrentCell.Value.ToString
    End Sub
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
        Select Case keyData
            Case Keys.Return
                ReturnSupplierBSPositionNameAndIDAndClose()
            Case Keys.Escape
                Me.DialogResult = DialogResult.Cancel
        End Select
        Return MyBase.ProcessCmdKey(msg, keyData)
    End Function
End Class