﻿Imports System.IO
Public Class dlgReklamationBearbeiten
    Private _ChangeFilePath As Boolean = False
    Private _NewFullFilePath As String

    Private Sub dlgReklamationBearbeiten_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim SelectedReclamation = Me.BSReklamation.At(Of DtsDaten.ReklamationRow)
        If SelectedReclamation.RowState = DataRowState.Detached Then
            If SelectedReclamation.IsDatumReklamationNull Then 'neu über UCReklamation
                NDTPDatumReklamation.Value = System.DateTime.Now
                CBLieferant.Select()
            Else 'neu über Drag and Drop
                CBReklamationsgrund.Select()
            End If
        Else 'bearbeiten über UCReklamation
                _ChangeFilePath = False
        End If
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNSave.Click, BTNDateiAuswaehlen.Click
        Select Case True
            Case sender Is BTNSave : ValidateUserInputAndSaveReclamation()
            Case sender Is BTNDateiAuswaehlen : ChooseReclamationFile()
        End Select
    End Sub
    Private Sub ValidateUserInputAndSaveReclamation()
        Dim CheckUserInput = CheckIfUserInputIsCorrect()
        If Not CheckUserInput.UserInputCorrect Then
            ShowAutoClosingMessageBox(CheckUserInput.ErrorText)
            Return
        End If

        If _ChangeFilePath AndAlso Not CopyFileToReclamationFolder() Then
            ShowAutoClosingMessageBox("Fehler beim kopieren der Reklamationsdatei")
            Return
        End If

        Me.ValidateChildren()
        Me.DialogResult = DialogResult.OK
    End Sub
    Private Function CheckIfUserInputIsCorrect() As (UserInputCorrect As Boolean, ErrorText As String)
        If NDTPDatumReklamation.Value Is Nothing Then Return (False, "kein Reklamationsdatum angegeben.")
        If CBLieferant.Text.IsEmpty Then Return (False, "kein Lieferant angegeben.")
        If CBReklamationsgrund.Text.IsEmpty Then Return (False, "kein Reklamationsgrund angegeben.")
        If CBReklamiertBei.Text.IsEmpty Then Return (False, "kein reklamiert bei angegeben.")
        If CBReklamiertVia.Text.IsEmpty Then Return (False, "kein reklamiert via angegeben.")
        Return (True, "")
    End Function
    Private Function CopyFileToReclamationFolder() As Boolean
        Dim FilePath = TBDateipfad.Text
        If FilePath.IsEmpty Then Return True
        Dim ReclaFile As FileInfo = New FileInfo(FilePath)
        If Not ReclaFile.Exists Then Return False
        Dim Suppliername = CBLieferant.Text
        Dim NewFileName As String
        Dim ReclamationReason = CBReklamationsgrund.Text
        If ReclamationReason.IsEmpty Then
            NewFileName = $"{CDate(NDTPDatumReklamation.Value.ToString).ToString("yyyy.MM.dd")} - Reklamation{ReclaFile.Extension}"
        Else
            NewFileName = $"{CDate(NDTPDatumReklamation.Value.ToString).ToString("yyyy.MM.dd")} - Reklamation - {ReclamationReason}{ReclaFile.Extension}"
        End If
        Dim TargetPath = New DirectoryInfo($"{My.Application.Info.DirectoryPath}\Daten\Reklamationen\{Suppliername}")
        Directory.CreateDirectory(TargetPath.FullName)
        _NewFullFilePath = $"{TargetPath.FullName}\{NewFileName}"

        Do While File.Exists(_NewFullFilePath)
            If ShowMessageBoxAndAskUserYesOrNo($"Die Datei {NewFileName} existiert bereits.{Environment.NewLine}Wollen Sie diese ersetzen?") Then
                Exit Do
            End If
            NewFileName = ModGlobalerCode.SetNewFilename(NewFileName, ReclaFile.Extension)
            _NewFullFilePath = $"{TargetPath.FullName}\{NewFileName}"
        Loop

        ReclaFile.CopyTo(_NewFullFilePath, True)
        Dim RelativePathToSave = $"{Suppliername}\{NewFileName}"
        TBDateipfad.Text = RelativePathToSave
        Return True
    End Function
    Private Sub ChooseReclamationFile()
        Using OFD As New OpenFileDialog With {.Filter = "alle Dateien | *.*", .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.Desktop, .Multiselect = False, .Title = "Rechnung auswählen"}
            If OFD.ShowDialog <> 1 Then Return
            TBDateipfad.Text = OFD.FileName
        End Using
    End Sub
    Private Sub dlgReklamationBearbeiten_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyData
            Case = Keys.Enter Or Keys.Control
                ValidateUserInputAndSaveReclamation()
            Case = Keys.Enter
                SendKeys.Send("{TAB}")
                e.SuppressKeyPress = True
        End Select
    End Sub
    Private Sub TBDateipfad_TextChanged(sender As Object, e As EventArgs) Handles TBDateipfad.TextChanged
        _ChangeFilePath = True
    End Sub
End Class