﻿Public Class dlgSpaltenAuswahl
    Public Property _AllColumns As New List(Of DataColumn)
    Public Property _ExportColumns As New List(Of DataColumn)
    Public Property _Exportcsv As Boolean = False
    Public Property _Delimiter As String
    Private Sub dlgSpaltenAuswahl_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        WriteListToDGV(_AllColumns, DGValleSpalten)
    End Sub
    Private Sub WriteListToDGV(Cols As List(Of DataColumn), DGV As DataGridView)
        DGV.Rows.Clear()
        For Each col In Cols
            DGV.Rows.Add(col.ColumnName)
        Next
    End Sub
    Private Sub DGValleSpalten_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGValleSpalten.CellClick
        _ExportColumns.Add(_AllColumns(DGValleSpalten.CurrentCell.RowIndex))
        WriteListToDGV(_ExportColumns, DGVExportSpalten)
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNSpalteLoeschen.Click, BTNRunter.Click,
        BTNOK.Click, BTNHoch.Click, BTNalleSpalten.Click
        Select Case True
            Case sender Is BTNOK : ValidateUserInputAndClose()
            Case sender Is BTNSpalteLoeschen : DeleteItemFromExportDGV()
            Case sender Is BTNRunter : MoveExportCellsUpOrDown(+1)
            Case sender Is BTNHoch : MoveExportCellsUpOrDown(-1)
            Case sender Is BTNalleSpalten : MoveAllColsToExport()
        End Select
    End Sub
    Private Sub ValidateUserInputAndClose()
        If _ExportColumns.Count = 0 Then
            ShowAutoClosingMessageBox("Bitte Exportspalten festlegen.")
            Return
        End If
        If _Exportcsv = True Then
            If TBCsvTrennzeichen.Text.IsEmpty Then
                ShowAutoClosingMessageBox("Bitte Trennzeichen festlegen")
                Return
            End If
        End If
        Me.DialogResult = DialogResult.OK
    End Sub
    Private Sub DeleteItemFromExportDGV()
        Dim DGVRowsCount = DGVExportSpalten.Rows.Count - 1
        If DGVRowsCount = -1 Then Return
        Dim index = (DGVExportSpalten.CurrentCell.RowIndex)
        _ExportColumns.RemoveAt(index)
        DGVRowsCount -= 1
        WriteListToDGV(_ExportColumns, DGVExportSpalten)
        selectItem(index, DGVRowsCount)
    End Sub
    Private Sub selectItem(index As Integer, DGVRowsCount As Integer)
        If DGVRowsCount = -1 Then Return
        If index = -1 Then Return
        If index > DGVRowsCount Then index -= 1
        DGVExportSpalten.Rows(index).Selected = True
        DGVExportSpalten.CurrentCell = DGVExportSpalten.Rows(index).Cells(0)
    End Sub
    Private Sub MoveExportCellsUpOrDown(direction As Integer)
        Dim DGVRowsCount = DGVExportSpalten.Rows.Count - 1
        Dim index = (DGVExportSpalten.CurrentCell.RowIndex)
        MoveItem(index, index + direction, DGVRowsCount)
        WriteListToDGV(_ExportColumns, DGVExportSpalten)
        selectItem(index + direction, DGVRowsCount)
    End Sub
    Private Sub MoveItem(index As Integer, destIndex As Integer, DGVRowsCount As Integer)
        If index = DGVRowsCount Then Return
        If index = 0 Then Return
        Dim item = _ExportColumns.Item(index)
        _ExportColumns.RemoveAt(index)
        _ExportColumns.Insert(destIndex, item)
    End Sub
    Private Sub MoveAllColsToExport()
        For Each item In _AllColumns
            _ExportColumns.Add(item)
        Next
        WriteListToDGV(_ExportColumns, DGVExportSpalten)
    End Sub
    Private Sub RB_CheckedChanged(sender As Object, e As EventArgs) Handles RBCSV.CheckedChanged
        _Exportcsv = RBCSV.Checked
    End Sub
    Private Sub TBCsvTrennzeichen_TextChanged(sender As Object, e As EventArgs) Handles TBCsvTrennzeichen.TextChanged
        _Delimiter = TBCsvTrennzeichen.Text
    End Sub
End Class