﻿Imports System.IO

Public Class dlgneuerDateiname

    Public Property _OldFileName As String
    Public Property _NewFileName As String
    Public Property _Extension As String
    Public Property _DefaultText As String

    Private Sub dlgneuerDateiname_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        LBLAlterDateiname.Text = _OldFileName
        LBLErweiterung.Text = _Extension
        If _DefaultText.IsNotEmpty Then TBNeuerDateiname.Text = $"{_DefaultText} "
    End Sub
    Private Sub BTNSpeichern_Click(sender As Object, e As EventArgs) Handles BTNSpeichern.Click
        If FileNameIsValid() Then SaveFileName()
    End Sub
    Private Function FileNameIsValid() As Boolean
        Dim NewFileName = TBNeuerDateiname.Text
        If NewFileName.IsEmpty Then
            ShowAutoClosingMessageBox("Der neue Dateiname darf nicht leer sein.")
            Return False
        End If
        Dim CheckForIllegalChars = NewFileName.CheckForIllegalChars((Path.GetInvalidFileNameChars() & Path.GetInvalidPathChars()).ToArray.Distinct.ToArray)
        If CheckForIllegalChars.ContainesIllegalChar Then
            ShowAutoClosingMessageBox($"Das Zeichen ""{CheckForIllegalChars.IllegalChar}"" darf nicht im Dateinamen enthalen sein.")
            Return False
        End If
        Return True
    End Function
    Private Sub SaveFileName()
        _NewFileName = TBNeuerDateiname.Text & _Extension
        Me.DialogResult = DialogResult.OK
    End Sub
    Private Sub dlgneuerDateiname_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyData
            Case = Keys.Enter
                SaveFileName()
                e.SuppressKeyPress = True
        End Select
    End Sub
End Class