﻿Imports System.ComponentModel
Imports System.IO
Imports OfficeOpenXml

Public Class frmArtikelBearbeiten
    Private _StopCalculateMargin As Boolean
    Private _StopCalculateRetailPrice As Boolean
    Private _StopCalculateDiscount As Boolean
    Private _StopCalculatePurchasingPrice As Boolean
    Private _CancelALLPriceEvents As Boolean
    Private _OldSalesMargin As Double
    Private _OldPurchasingPrice As Decimal
    Private _OldRetailPrice As Decimal
    Private _OldEAN As String
    Private _OldArtNr As String
    Private _BS As New BindingSource
    Private _tbl As New DataTable

    Public Property _SelectedItem As DtsDaten.ArtikelRow
    Public Property _CopyItem As Boolean
    Public Property _EditItem As Boolean
    Public Property _ShowImport As Boolean
    Private Sub frmArtikelBearbeiten_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        My.Settings.ArtikelBearbeitenFormPosition = Me.Location
    End Sub
    Private Sub frmArtikelBearbeiten_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        RegisterNumericTextboxInput(TBListenEK, TBRabatt, TBEK, TBMarge, TBVk, TBVe)
        Me.Location = My.Settings.ArtikelBearbeitenFormPosition
        If Not _SelectedItem Is Nothing Then
            LoadItemData()
        Else
            CCBLieferant.Clear()
        End If
        If _ShowImport Then PrepareFormForImport()
        If CBSteuer.Text.IsEmpty Then CBSteuer.Text = "19"
    End Sub
    Private Sub PrepareFormForImport()
        SCMain.Panel2Collapsed = False
        Me.Height += 400
        SCMain.SplitterDistance = 391
        BTNAbbrechen.Text = "schließen"
    End Sub
    Private Sub LoadItemData()
        _CancelALLPriceEvents = True
        With _SelectedItem
            CCBLieferant.SetMeNotEmpty()
            CCBLieferant.Text = .LieferantRow.Name
            CBKategorie.Text = .KategorieRow.Name
            CBWarengruppe.Text = .WarengruppeRow.Name
            TBName.Text = .Name1
            TBZusatz.Text = .Zusatz
            TBVe.Text = .Ve.ToString
            TBListenEK.Text = .Listenpreis.ToString("#,#0.00")
            TBRabatt.Text = .Rabatt.ToString("#,#0.00")
            TBEK.Text = .Einkaufspreis.ToString("#,#0.00")
            CBSteuer.Text = .Steuer.ToString
            TBMarge.Text = .Marge.ToString("#,#0.00")
            _OldSalesMargin = .Marge
            TBVk.Text = .Verkaufspreis.ToString("#,#0.00")
            CBXAuslauf.Checked = .auslauf
            If _CopyItem Then
                TBArtNr.Text = increaseArtNRByOne(.ArtNr.ToString)
            End If
            If _EditItem Then
                _OldArtNr = .ArtNr.ToString
                TBArtNr.Text = .ArtNr.ToString
                _OldEAN = .EAN
                TBEAN.Text = .EAN
                _OldPurchasingPrice = .Einkaufspreis
                _OldRetailPrice = .Verkaufspreis
                If Not .IsalterEinkaufpreisNull Then TBAlterEK.Text = .alterEinkaufpreis.ToString("#,#0.00")
                If Not .IsalterVerkaufspreisNull Then TBAlterVK.Text = .alterVerkaufspreis.ToString("#,#0.00")
                If Not .IsDatumLetzteKalkulationEKNull Then TBDatumLetzteKalkEK.Text = .DatumLetzteKalkulationEK.ToString("dd.MM.yy")
                If Not .IsDatumletzteKalkulationVKNull Then TBDatumLetzteKalkVK.Text = .DatumletzteKalkulationVK.ToString("dd.MM.yy")
            End If

        End With
        _CancelALLPriceEvents = False
    End Sub
    Private Function increaseArtNRByOne(ArtNr As String) As String
        Dim chars = ArtNr.ToList
        Dim NewArtNr = ""
        Dim i = chars.FindLastIndex(Function(c) "012345678".Contains(c))
        Dim numb = 0
        If i < 0 OrElse Not Integer.TryParse(ArtNr.Substring(i), numb) Then
            NewArtNr = ArtNr & "0"
        Else
            numb += 1
            Dim frmt = New String("0"c, chars.Count - i)
            NewArtNr = $"{ ArtNr.Substring(0, i)}{numb.ToString(frmt)}"
        End If

        Dim dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim SelectedSupplier = BSLieferant.At(Of DtsDaten.LieferantRow)
            If Not dts.Artikel.ArtNrExistsWithinASupplier(NewArtNr, SelectedSupplier) Then
                Return NewArtNr
            Else
                Return increaseArtNRByOne(NewArtNr)
        End If
    End Function
    Private Sub CBLieferant_SelectedIndexChanged(sender As Object, e As EventArgs)
        LBLFehlerText.Text = ""
    End Sub
    Private Sub TBArtNR_TextChanged(sender As Object, e As EventArgs) Handles TBArtNr.TextChanged
        If _ShowImport Then
            LoadItemDataIfArticleNumberExisting()
        Else
            LookUpExistingArticleNumber()
        End If
    End Sub
    Private Sub LoadItemDataIfArticleNumberExisting()
        Dim dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim SelectedSupplier = BSLieferant.At(Of DtsDaten.LieferantRow)
        If dts.Artikel.ArtNrExistsWithinASupplier(TBArtNr.Text, SelectedSupplier) Then
            LBLArtikelGefunden.Text = "Artikel wird bearbeitet"
            _EditItem = True
            _SelectedItem = FindArticleByNumber(TBArtNr.Text, SelectedSupplier)
            LoadItemData()
        End If
    End Sub
    Private Function FindArticleByNumber(ArtNo As String, Supplier As DtsDaten.LieferantRow) As DtsDaten.ArtikelRow
        Dim ArticleListBySupplier = Supplier.GetArtikelRows
        For Each Item In ArticleListBySupplier
            If Item.ArtNr = ArtNo Then Return Item
        Next
        Return Nothing
    End Function
    Private Sub LookUpExistingArticleNumber()
        Dim dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim SelectedSupplier = BSLieferant.At(Of DtsDaten.LieferantRow)
        If _OldArtNr <> TBArtNr.Text AndAlso dts.Artikel.ArtNrExistsWithinASupplier(TBArtNr.Text, SelectedSupplier) Then
            LBLFehlerText.Text = "Artikelnummer bereits verwendet"
            Return
        Else
            LBLFehlerText.Text = ""
        End If
    End Sub
    Private Sub TBEAN_TextChanged(sender As Object, e As EventArgs) Handles TBEAN.TextChanged
        Dim dts = DirectCast(BSMain.DataSource, DtsDaten)
        If _OldEAN <> TBEAN.Text AndAlso dts.Artikel.EANExists(TBEAN.Text) Then
            LBLFehlerText.Text = "EAN bereits verwendet"
            Return
        Else
            LBLFehlerText.Text = ""
        End If
    End Sub

    Private Sub ClickEvents(sender As Object, e As EventArgs) Handles BTNVolleMarge.Click, BTNOK.Click, BTNAbbrechen.Click, BTNAlteMarge.Click,
            BTNEANSuche.Click, BTNNamensSuche.Click, BTNArikelImportieren.Click, BTNArtikelExportieren.Click, BTNSucheLoeschen.Click
        Select Case True
            Case sender Is BTNVolleMarge : SetMarginTo100Percent()
            Case sender Is BTNAlteMarge : SetMarginToOldValue()
            Case sender Is BTNAbbrechen : CloseForm()
            Case sender Is BTNOK : ValidateUserInputAndSaveItem()
            Case sender Is BTNEANSuche : SearchItemOnTheInternet(TBEAN.Text)
            Case sender Is BTNNamensSuche : SearchItemOnTheInternet(TBName.Text)
            Case sender Is BTNArikelImportieren : ImportItemData()
            Case sender Is BTNArtikelExportieren : ExportItemData()
            Case sender Is BTNSucheLoeschen : ClearItemSearch()
        End Select
    End Sub
    Private Sub SetMarginTo100Percent()
        _StopCalculateMargin = True
        TBMarge.Text = "100"
        _StopCalculateMargin = False
    End Sub
    Private Sub SetMarginToOldValue()
        _StopCalculateMargin = True
        TBMarge.Text = _OldSalesMargin.ToString
        _StopCalculateMargin = False
    End Sub
    Private Sub CloseForm()
        Me.Close()
    End Sub
    Private Sub ValidateUserInputAndSaveItem()
        Dim UserInputCheck = ValidateUserInput()
        If UserInputCheck.UserInputCorrect Then
            If _EditItem Then
                SaveItemData(_SelectedItem)
            Else
                Dim dts = DirectCast(BSMain.DataSource, DtsDaten)
                Dim NewItemrow As DtsDaten.ArtikelRow
                NewItemrow = dts.Artikel.NewArtikelRow()
                SaveItemData(NewItemrow)
                dts.Artikel.Rows.Add(NewItemrow)
            End If
            If Not _ShowImport Then
                CloseForm()
            Else
                DeleteSelectedDGVRowAndSelectNext()
            End If
        Else
            LBLFehlerText.Text = UserInputCheck.Errortext
        End If
    End Sub
    Private Sub DeleteSelectedDGVRowAndSelectNext()
        If DGVArtikel.CurrentRow Is Nothing Then Exit Sub
        Dim row As Integer = DGVArtikel.CurrentRow.Index
        DGVArtikel.Rows.Remove(DGVArtikel.CurrentRow)
        If row = DGVArtikel.RowCount Then Exit Sub
        DGVArtikel.Item(0, row).Selected = True
    End Sub
    Private Function ValidateUserInput() As (UserInputCorrect As Boolean, Errortext As String)
        Dim dts = DirectCast(BSMain.DataSource, DtsDaten)
        If TBArtNr.Text.IsEmpty Then Return (False, "Artikelnummer darf nicht leer sein")
        If CCBLieferant.IsEmpty Then Return (False, "Lieferant darf nicht leer sein")
        If TBName.Text.IsEmpty Then Return (False, "Name darf nicht leer sein")
        If TBVe.Text.IsEmpty Then Return (False, "Ve darf nicht leer sein")
        If TBListenEK.Text.IsEmpty Then Return (False, "ListenEK darf nicht leer sein")
        If TBEK.Text.IsEmpty Then Return (False, "EK darf nicht leer sein")
        If TBMarge.Text.IsEmpty Then Return (False, "Spanne darf nicht leer sein")
        If TBVk.Text.IsEmpty Then Return (False, "VK darf nicht leer sein")
        If Not Integer.TryParse(TBVe.Text, 0) Then Return (False, "Ve muss ganzzahlig sein")
        If CBSteuer.Text <> "7" And CBSteuer.Text <> "19" Then Return (False, "ungültige Mehrwertsteuer")
        Dim SelectedSupplier = BSLieferant.At(Of DtsDaten.LieferantRow)
        If _OldArtNr <> TBArtNr.Text AndAlso dts.Artikel.ArtNrExistsWithinASupplier(TBArtNr.Text, SelectedSupplier) Then Return (False, "Artikelnummer bereits verwendet")
        If _OldEAN <> TBEAN.Text AndAlso dts.Artikel.EANExists(TBEAN.Text) Then Return (False, "EAN wird bereits verwendet")
        If CheckForControlChars(TBArtNr) Then Return (False, "ungültiges Zeichen in der Artikelnummer")
        If CheckForControlChars(TBEAN) Then Return (False, "ungültiges Zeichen im EAN")
        If CheckForControlChars(TBName) Then Return (False, "ungültiges Zeichen im Namen")
        If CheckForControlChars(TBZusatz) Then Return (False, "ungültiges Zeichen im Namenszusatz")
        If CheckForControlChars(TBNotiz) Then Return (False, "ungültiges Zeichen in der Notiz")
        Return (True, "")
    End Function
    Private Sub SaveItemData(Itemrow As DtsDaten.ArtikelRow)
        Dim SelectedSupplier = BSLieferant.At(Of DtsDaten.LieferantRow)
        Dim SelectedCategory = BSKategorie.At(Of DtsDaten.KategorieRow)
        Dim SelectedProductGroup = BSWarengruppe.At(Of DtsDaten.WarengruppeRow)
        With Itemrow
            .ArtNr = TBArtNr.Text
            .EAN = TBEAN.Text
            .Name1 = TBName.Text
            .Zusatz = TBZusatz.Text
            .Ve = CInt(TBVe.Text)
            .Listenpreis = CDec(TBListenEK.Text)
            .Rabatt = CDec(TBRabatt.Text)
            .Einkaufspreis = CDec(TBEK.Text)
            .Marge = CDbl(TBMarge.Text)
            .Verkaufspreis = CDec(TBVk.Text)
            .Steuer = CInt(CBSteuer.Text)
            .Notiz = TBNotiz.Text
            .auslauf = CBXAuslauf.Checked
            .LieferantRow = SelectedSupplier
            .KategorieRow = SelectedCategory
            .WarengruppeRow = SelectedProductGroup
            If _EditItem Then
                SaveOldPurchasingPriceIfChanged(Itemrow)
                SaveOldRetailPriceIfChanged(Itemrow)
            End If
        End With
    End Sub
    Private Sub SaveOldPurchasingPriceIfChanged(Itemrow As DtsDaten.ArtikelRow)
        If Double.Parse(TBEK.Text) <> _OldPurchasingPrice Then
            Itemrow.alterEinkaufpreis = _OldPurchasingPrice
            Itemrow.DatumLetzteKalkulationEK = System.DateTime.Now
        End If
    End Sub
    Private Sub SaveOldRetailPriceIfChanged(Itemrow As DtsDaten.ArtikelRow)
        If Double.Parse(TBVk.Text) <> _OldRetailPrice Then
            Itemrow.alterVerkaufspreis = _OldRetailPrice
            Itemrow.DatumletzteKalkulationVK = System.DateTime.Now
        End If
    End Sub
    Private Sub SearchItemOnTheInternet(Searchtext As String)
        If Searchtext.IsNotEmpty Then Process.Start($"https://www.google.com/search?q={Searchtext}&sa=X&tbm=shop&sxsrf=ALeKk01PGvf0eyXswlBQNImUkE_N92PVwg%3A1628509097389&ei=qBMRYYuxN8iK8gLjjr_QCA&oq=718207518241&gs_lcp=Cgtwcm9kdWN0cy1jYxADMgQIIxAnUABYAGDqEmgBcAB4AIABV4gBV5IBATGYAQCgAQLAAQE&sclient=products-cc&ved=0ahUKEwiLpfCR7aPyAhVIhVwKHWPHD4oQ4dUDCAY&uact=5")
    End Sub
    Private Sub TBPrices_TextChange(sender As Object, e As EventArgs) Handles TBListenEK.TextChanged, TBRabatt.TextChanged,
            CBSteuer.TextChanged, TBMarge.TextChanged, TBVk.TextChanged, TBEK.TextChanged
        If _CancelALLPriceEvents Then Return
        Select Case True
            Case sender Is TBListenEK : CalculatePurchasingPrice()
            Case sender Is TBRabatt : CalculatePurchasingPrice()
            Case sender Is TBEK
                CalculateMargin()
                CalculateDiscount()
            Case sender Is CBSteuer : CalculateMargin()
            Case sender Is TBMarge : CalculateRetailPrice()
            Case sender Is TBVk : CalculateMargin()
        End Select
    End Sub
    Private Sub TBPrices_GotFocus(sender As Object, e As EventArgs) Handles TBVk.GotFocus, TBMarge.GotFocus,
            TBRabatt.GotFocus, TBEK.GotFocus
        Select Case True
            Case sender Is TBVk : _StopCalculateRetailPrice = True
            Case sender Is TBEK : _StopCalculatePurchasingPrice = True
            Case sender Is TBMarge : _StopCalculateMargin = True
            Case sender Is TBRabatt : _StopCalculateDiscount = True
        End Select
    End Sub
    Private Sub TBPrices_LostFocus(sender As Object, e As EventArgs) Handles TBVk.LostFocus, TBMarge.LostFocus,
            TBRabatt.LostFocus, TBEK.LostFocus
        Select Case True
            Case sender Is TBVk : _StopCalculateRetailPrice = False
            Case sender Is TBEK : _StopCalculatePurchasingPrice = False
            Case sender Is TBMarge : _StopCalculateMargin = False
            Case sender Is TBRabatt : _StopCalculateDiscount = False
        End Select
    End Sub
    Private Sub CalculatePurchasingPrice()
        If _StopCalculatePurchasingPrice Then Return
        Dim ListPrice As Double
        Dim Discount As Double
        If Not Double.TryParse(TBListenEK.Text, ListPrice) Then Return
        If Not Double.TryParse(TBRabatt.Text, Discount) Then TBRabatt.Text = "0"
        TBEK.Text = (ListPrice * (100 - Discount) / 100).ToString("0.00")
    End Sub
    Private Sub CalculateDiscount()
        If _StopCalculateDiscount Then Return
        Dim ListPrice As Double
        Dim PurchasingPrice As Double
        Dim DiscountAbsolut As Double
        If Not Double.TryParse(TBListenEK.Text, ListPrice) Then Return
        If Not Double.TryParse(TBEK.Text, PurchasingPrice) Then Return
        DiscountAbsolut = ListPrice - PurchasingPrice
        If DiscountAbsolut = 0 Then
            TBRabatt.Text = "0"
        Else
            TBRabatt.Text = ((DiscountAbsolut * 100) / ListPrice).ToString("0.00")
        End If
    End Sub
    Private Sub CalculateMargin()
        If _StopCalculateMargin Then Return
        Dim PurchasingPrice As Double
        Dim RetailPrice As Double
        Dim Taxes As Double
        If Not Double.TryParse(TBEK.Text, PurchasingPrice) Then Return
        If Not Double.TryParse(TBVk.Text, RetailPrice) Then Return
        If Not Double.TryParse(CBSteuer.Text, Taxes) Then Return
        TBMarge.Text = ((RetailPrice / (100 + Taxes) * 100 / PurchasingPrice * 100) - 100).ToString("0.###")
    End Sub
    Private Sub CalculateRetailPrice()
        If _StopCalculateRetailPrice Then Return
        Dim PurchasingPrice As Double
        Dim SalesMargin As Double
        Dim Taxes As Double
        If Not Double.TryParse(TBEK.Text, PurchasingPrice) Then Return
        If Not Double.TryParse(TBMarge.Text, SalesMargin) Then Return
        If Not Double.TryParse(CBSteuer.Text, Taxes) Then Return
        If PurchasingPrice > 0 Then
            TBVk.Text = ((PurchasingPrice * (SalesMargin / 100) + PurchasingPrice) * (100 + Taxes) / 100).ToString("0.00")
        End If
    End Sub
    Private Sub ImportItemData()
        _EditItem = False
        Dim Filepath As String
        Using O As New OpenFileDialog With {.Filter = "Preislisten(*.xls, *.xlsx, *.csv) | *.xls;*.xlsx;*.csv", .Multiselect = False, .Title = "Rechnung auswählen"}
            O.InitialDirectory = "..\\..\\"
            If O.ShowDialog <> 1 Then Return
            Filepath = O.FileName
        End Using
        Dim extension = Path.GetExtension(Filepath)
        _tbl = New DataTable
        If extension = ".csv" Then
            Importcsv(Filepath)
        Else
            ImportExcel(Filepath)
        End If

        _SelectedItem = Nothing

        BindDGVTOBS()

        ChangeDGVHeaders()

    End Sub
    Private Sub Importcsv(Filepath As String)
        Dim Colcount As Integer
        Dim lines = IO.File.ReadAllLines(Filepath)
        Colcount = lines.First.Split(";"c).Length
        For i = 0 To Colcount
            _tbl.Columns.Add(New DataColumn("Column_" & i, GetType(String)))
        Next
        For Each line In lines
            Dim objFields = (From field In line.Split(";"c)).ToList()
            Dim count As Integer = 0
            For Each item In objFields
                count += 1
                If count > Colcount Then
                    _tbl.Columns.Add(New DataColumn("Column_" & count, GetType(String)))
                    Colcount += 1
                End If
            Next
            objFields.Insert(0, line)
            Dim newRow = _tbl.Rows.Add()
            newRow.ItemArray = objFields.ToArray()
        Next
    End Sub
    Private Sub ImportExcel(Filepath As String)
        Dim ColCount As Integer
        Dim ExcelFile As FileInfo = New FileInfo(Filepath)
        Using package As ExcelPackage = New ExcelPackage(ExcelFile)
            Dim worksheet As ExcelWorksheet = package.Workbook.Worksheets(1)
            ColCount = worksheet.Dimension.[End].Column
            For i = 0 To ColCount
                _tbl.Columns.Add(New DataColumn("Column_" & i, GetType(String)))
            Next

            Dim line As String = ""
            For i = 1 To worksheet.Dimension.[End].Row
                Dim objFields As New List(Of String)
                For j = 1 To ColCount
                    If worksheet.Cells(i, j).Value IsNot Nothing Then
                        objFields.Add(worksheet.Cells(i, j).Value.ToString)
                        line &= worksheet.Cells(i, j).Value.ToString
                    Else
                        objFields.Add("")
                    End If
                Next
                objFields.Insert(0, line)
                line = ""
                Dim newRow = _tbl.Rows.Add()
                newRow.ItemArray = objFields.ToArray()
            Next
        End Using
    End Sub
    Private Sub BindDGVTOBS()
        _BS.DataSource = _tbl
        _BS.Filter = String.Empty
        DGVArtikel.DataSource = _BS
        DGVArtikel.Columns("Column_0").Visible = False
    End Sub
    Private Sub ChangeDGVHeaders()
        If DGVArtikel.Rows.Count = 0 Then Return
        Dim Tempinteger As Integer
        Dim SPArtNr As Integer = -1
        Dim SPEan As Integer = -1
        Dim SPName As Integer = -1
        Dim SPVe As Integer = -1
        Dim SPEk As Integer = -1
        Dim SPVK As Integer = -1
        Dim SPTaxes As Integer = -1
        Dim SPDiscount As Integer = -1
        Dim SPNote As Integer = -1
        Dim SPSupplier As Integer = -1

        If TBSPArtNr.Text <> "" AndAlso Integer.TryParse(TBSPArtNr.Text, Tempinteger) Then SPArtNr = Tempinteger
        If TBSPEAN.Text <> "" AndAlso Integer.TryParse(TBSPEAN.Text, Tempinteger) Then SPEan = Tempinteger
        If TBSPName.Text <> "" AndAlso Integer.TryParse(TBSPName.Text, Tempinteger) Then SPName = Tempinteger
        If TBSPVe.Text <> "" AndAlso Integer.TryParse(TBSPVe.Text, Tempinteger) Then SPVe = Tempinteger
        If TBSPEK.Text <> "" AndAlso Integer.TryParse(TBSPEK.Text, Tempinteger) Then SPEk = Tempinteger
        If TBSPVK.Text <> "" AndAlso Integer.TryParse(TBSPVK.Text, Tempinteger) Then SPVK = Tempinteger
        If TBSPSteuer.Text <> "" AndAlso Integer.TryParse(TBSPSteuer.Text, Tempinteger) Then SPTaxes = Tempinteger
        If TBSPRabatt.Text <> "" AndAlso Integer.TryParse(TBSPRabatt.Text, Tempinteger) Then SPDiscount = Tempinteger
        If TBSPNotiz.Text <> "" AndAlso Integer.TryParse(TBSPNotiz.Text, Tempinteger) Then SPNote = Tempinteger
        If TBSPLieferant.Text <> "" AndAlso Integer.TryParse(TBSPLieferant.Text, Tempinteger) Then SPSupplier = Tempinteger

        With DGVArtikel
            For i = 0 To .ColumnCount - 1
                .Columns(i).HeaderText = "Spalte " & i
            Next
            If SPArtNr <> -1 AndAlso SPArtNr <= .ColumnCount - 1 Then .Columns(SPArtNr).HeaderText = "Art. Nr."
            If SPEan <> -1 AndAlso SPEan <= .ColumnCount - 1 Then .Columns(SPEan).HeaderText = "Ean"
            If SPName <> -1 AndAlso SPName <= .ColumnCount - 1 Then .Columns(SPName).HeaderText = "Name"
            If SPVe <> -1 AndAlso SPVe <= .ColumnCount - 1 Then .Columns(SPVe).HeaderText = "Ve"
            If SPEk <> -1 AndAlso SPEk <= .ColumnCount - 1 Then .Columns(SPEk).HeaderText = "Ek"
            If SPVK <> -1 AndAlso SPVK <= .ColumnCount - 1 Then .Columns(SPVK).HeaderText = "Vk"
            If SPTaxes <> -1 AndAlso SPTaxes <= .ColumnCount - 1 Then .Columns(SPTaxes).HeaderText = "Mwst."
            If SPDiscount <> -1 AndAlso SPDiscount <= .ColumnCount - 1 Then .Columns(SPDiscount).HeaderText = "Rabatt"
            If SPNote <> -1 AndAlso SPNote <= .ColumnCount - 1 Then .Columns(SPNote).HeaderText = "Notiz"
            If SPSupplier <> -1 AndAlso SPSupplier <= .ColumnCount - 1 Then .Columns(SPSupplier).HeaderText = "Lieferant"
        End With
    End Sub
    Private Sub TBSP_TextChanged(sender As Object, e As EventArgs) Handles TBSPVK.TextChanged, TBSPVe.TextChanged, TBSPSteuer.TextChanged, TBSPRabatt.TextChanged, TBSPNotiz.TextChanged, TBSPName.TextChanged, TBSPLieferant.TextChanged, TBSPEK.TextChanged, TBSPEAN.TextChanged, TBSPArtNr.TextChanged
        ChangeDGVHeaders()
    End Sub
    Private Sub ExportItemData()
        Dim Delimiter As Char = ";"c
        Dim CompleteFileName As String

        Dim SFD As New SaveFileDialog
        With SFD
            .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.Desktop
            .Title = "Liste expotieren"
            .DefaultExt = "csv"
            .Filter = "csv Dateien (*.csv)|*.csv"
        End With
        If (SFD.ShowDialog() = DialogResult.OK) Then
            CompleteFileName = SFD.FileName
        Else
            Return
        End If

        Dim csvFile As String = ""

        For i = 1 To DGVArtikel.Columns.Count - 1
            csvFile &= DGVArtikel.Columns(i).HeaderText & Delimiter
        Next

        csvFile = csvFile.TrimEnd(Delimiter)
        csvFile &= Environment.NewLine

        For i = 0 To DGVArtikel.Rows.Count - 1
            For j = 1 To DGVArtikel.Columns.Count - 1
                If Not DGVArtikel(j, i).Value Is Nothing Then
                    csvFile &= DGVArtikel(j, i).Value.ToString & Delimiter
                Else
                    csvFile &= Delimiter
                End If
            Next
            csvFile = csvFile.TrimEnd(Delimiter)
            csvFile &= Environment.NewLine
        Next

        My.Computer.FileSystem.WriteAllText(CompleteFileName, csvFile, False)

        ShowAutoClosingMessageBox("Datei erfolgreich exportiert")

    End Sub
    Private Sub ClearItemSearch()
        TBArtikelDurchsuchen.Text = ""
    End Sub
    Private Sub TBArtikelDurchsuchen_TextChanged(sender As Object, e As EventArgs) Handles TBArtikelDurchsuchen.TextChanged
        SearchItem()
    End Sub
    Private Sub SearchItem()
        _BS.Filter = String.Empty
        If TBArtikelDurchsuchen.Text.Length > 0 AndAlso _tbl.Rows.Count > 0 Then
            Try
                _BS.Filter = $"[Column_0] like '*{TBArtikelDurchsuchen.Text}*'"
            Catch ex As Exception
                _BS.Filter = String.Empty
            End Try
        End If
    End Sub
    Private Sub DGVArtikel_SelectionChanged(sender As Object, e As EventArgs) Handles DGVArtikel.SelectionChanged
        WriteArticleDataToTextBoxes()
    End Sub
    Private Sub WriteArticleDataToTextBoxes()
        LBLArtikelGefunden.Text = ""
        If DGVArtikel.Rows.Count = 0 Then Exit Sub
        Dim RowIndex As Integer = DGVArtikel.CurrentRow.Index

        ClearTextBoxes()

        WriteItemData(RowIndex, TBSPArtNr, TBArtNr, False)
        WriteItemData(RowIndex, TBSPEAN, TBEAN, False)
        WriteItemData(RowIndex, TBSPName, TBName, False)
        WriteItemData(RowIndex, TBSPVe, TBVe, True)
        WriteItemData(RowIndex, TBSPEK, TBListenEK, True)
        WriteItemData(RowIndex, TBSPVK, TBVk, True)
        WriteItemData(RowIndex, TBSPSteuer, CBSteuer, True)
        WriteItemData(RowIndex, TBSPLieferant, CCBLieferant, True)
        WriteItemData(RowIndex, TBSPRabatt, TBRabatt, True)
        WriteItemData(RowIndex, TBSPNotiz, TBNotiz, True)
        SetSupplier(RowIndex, TBSPLieferant)

        If TBVk.Text.IsNotEmpty AndAlso TBEK.Text.IsNotEmpty Then CalculateMargin()

    End Sub
    Private Sub ClearTextBoxes()
        TBArtNr.Text = ""
        TBEAN.Text = ""
        CCBLieferant.Clear()
        CBKategorie.Text = ""
        TBName.Text = ""
        TBZusatz.Text = ""
        TBVe.Text = ""
        TBListenEK.Text = ""
        TBRabatt.Text = ""
        TBEK.Text = ""
        CBSteuer.Text = ""
        TBMarge.Text = ""
        TBVk.Text = ""
        TBNotiz.Text = ""
    End Sub
    Private Sub WriteItemData(Rowindex As Integer, ColumnTextBox As TextBox, ControlToWrite As Control, AllowFixedText As Boolean)
        Dim ColumnIndex As Integer
        If Integer.TryParse(ColumnTextBox.Text, ColumnIndex) AndAlso ColumnIndex > 0 Then
            If ColumnIndex - 1 <= DGVArtikel.ColumnCount Then
                If DGVArtikel.Rows(Rowindex).Cells(ColumnIndex).Value IsNot Nothing Then ControlToWrite.Text = DGVArtikel.Rows(Rowindex).Cells(ColumnIndex).Value.ToString
            End If
        ElseIf AllowFixedText Then
            Dim FixedText As String = ColumnTextBox.Text
            If FixedText.Length > 0 Then
                If FixedText.Substring(0, 1) = "=" Then
                    ControlToWrite.Text = FixedText.Substring(1, FixedText.Length - 1)
                End If
            End If
        End If
    End Sub
    Private Sub SetSupplier(RowIndex As Integer, ColumnTextBox As TextBox)
        Dim ColumnIndex As Integer
        Dim SupplierName As String
        If Integer.TryParse(ColumnTextBox.Text, ColumnIndex) AndAlso ColumnIndex > 0 Then
            If ColumnIndex - 1 <= DGVArtikel.ColumnCount Then
                If DGVArtikel.Rows(RowIndex).Cells(ColumnIndex).Value IsNot Nothing Then
                    SupplierName = DGVArtikel.Rows(RowIndex).Cells(ColumnIndex).Value.ToString
                End If
            End If
        End If
        If SupplierName.IsEmpty Then
            CCBLieferant.Clear()
            Return
        Else
            CCBLieferant.UndoClear()
        End If

        Dim dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim SelectedSupplier = dts.Lieferant.FindSupplierByName(SupplierName)

        For i = 0 To BSLieferant.Count - 1
            If DirectCast(BSLieferant.Item(i), DataRowView).Row Is SelectedSupplier Then BSLieferant.Position = i
        Next
    End Sub
    Private Sub frmArtikelBearbeiten_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyData
            Case = Keys.Enter Or Keys.Control
                ValidateUserInputAndSaveItem()
            Case = Keys.Escape
                CloseForm()
            Case = Keys.Enter
                SendKeys.Send("{TAB}")
                e.SuppressKeyPress = True
        End Select
    End Sub
    Private Sub LBLEan_Click(sender As Object, e As EventArgs)
        Dim Settingsrow = DirectCast(DirectCast(BSEinstellungen.Current, DataRowView).Row, DtsDaten.EinstellungRow)
        Dim EAN12 As String = Settingsrow.EAN.ToString
        Dim Numbers() As Char = EAN12.ToCharArray
        Dim Multiplikator As Integer = 1
        Dim CheckNumber As Integer = 0
        Dim numb = 0
        For Each c As Char In Numbers
            If Integer.TryParse(c, numb) Then
                CheckNumber += (numb Mod 10) * Multiplikator
                Multiplikator = If(Multiplikator = 1, 3, 1)
            End If
        Next
        Dim check = CheckNumber Mod 10
        If check > 0 Then
            CheckNumber = 10 - (CheckNumber Mod 10)
        Else
            CheckNumber = 0
        End If
        Dim EAN13 = EAN12 & CheckNumber.ToString
        TBEAN.Text = EAN13.ToString
        Settingsrow.EAN += 1
    End Sub
End Class