﻿Imports System.IO
Public Class frmDateiAuswahl
    Public Property _Path As String
    Public Property _Filename As String
    Public Property _ShowAllFilesInFolder As Boolean = True
    Public Property _FilenameToShow As String
    Private Sub dlgDateiAuswahl_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ReloadFilesList()
    End Sub
    Private Sub DGVDateiname_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVDateiname.CellClick
        _Filename = DGVDateiname.Item(0, DGVDateiname.CurrentCell.RowIndex).Value.ToString
    End Sub
    Private Sub DGVDateiname_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVDateiname.CellDoubleClick
        OpenFile()
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNVerschieben.Click, BTNUmbenennen.Click, BTNOK.Click,
        BTNLoeschen.Click, BTNDesktopKopieren.Click, BTNAbbrechen.Click
        Select Case True
            Case sender Is BTNOK : OpenFile()
            Case sender Is BTNVerschieben : MoveFile()
            Case sender Is BTNUmbenennen : RenameFile()
            Case sender Is BTNLoeschen : DeleteFile()
            Case sender Is BTNDesktopKopieren : CopyFileToDesktop()
            Case sender Is BTNAbbrechen : CloseForm()
        End Select
    End Sub
    Private Sub OpenFile()
        If Not PathExists() Then Return
        If Not FileSelected() Then Return
        Process.Start(_Path & _Filename)
        CloseForm()
    End Sub
    Private Sub MoveFile()
        If Not PathExists() Then Return
        If Not FileSelected() Then Return

        Dim files(0) As String
        If File.Exists(_Path & _Filename) Then
            files(0) = _Path & _Filename
            frmHaupt.processDroppedFiles(files, True)
            ReloadFilesList()
        End If
    End Sub
    Private Sub RenameFile()
        If Not PathExists() Then Return
        If Not FileSelected() Then Return

        If File.Exists(_Path & _Filename) Then
            Dim FileInfo As FileInfo = New FileInfo(_Path & _Filename)
            Dim extension = FileInfo.Extension
            Dim newname As String = Microsoft.VisualBasic.InputBox("Bitte den neuen Dateinamen ohne Endung eingeben", "Datei umbenennen", Path.GetFileNameWithoutExtension(_Filename))
            If newname.IsEmpty Then
                Return
            Else
                newname &= extension
            End If

            If Not File.Exists(_Path & newname) Then
                Microsoft.VisualBasic.Rename(_Path & _Filename, _Path & newname)
                ReloadFilesList()
            Else
                ShowAutoClosingMessageBox($"Umbennen nicht möglich {Environment.NewLine} Dieser Dateiname existiert bereits.")
            End If
        End If
    End Sub
    Private Sub DeleteFile()
        If Not PathExists() Then Return
        If Not FileSelected() Then Return

        If File.Exists(_Path & _Filename) Then
            If ShowMessageBoxAndAskUserYesOrNo($"Wollen Sie die Datei {_Filename} wirklich löschen?") Then
                My.Computer.FileSystem.DeleteFile(_Path & _Filename)
            End If
            ReloadFilesList()
        End If
    End Sub
    Private Sub CopyFileToDesktop()
        Dim FileInfo As FileInfo = New FileInfo(_Path & _Filename)
        FileInfo.CopyTo($"{Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory)}\{FileInfo.Name}", True)
        ShowAutoClosingMessageBox("Die Datei wurde auf den Desktopn kopiert.")
    End Sub
    Private Sub CloseForm()
        Me.Close()
    End Sub
    Private Sub ReloadFilesList()
        Dim Files() As FileInfo
        If _ShowAllFilesInFolder Then
            Files = New DirectoryInfo(_Path).GetFiles("*.*")
        Else
            Files = New DirectoryInfo(_Path).GetFiles(_FilenameToShow + "*.*")
        End If
        DGVDateiname.Rows.Clear()
        For Each File In files
            DGVDateiname.Rows.Add(File.Name)
        Next
        DGVDateiname.ClearSelection()
    End Sub
    Private Function PathExists() As Boolean
        If _Path.IsEmpty Then
            ShowAutoClosingMessageBox("Fehler beim laden des Pfades.")
            Return False
        End If
        Return True
    End Function
    Private Function FileSelected() As Boolean
        If _Filename.IsEmpty Then
            ShowAutoClosingMessageBox("Bitte eine Datei auswählen.")
            Return False
        End If
        Return True
    End Function
    Private Sub frmDateiAuswahl_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyData
            Case = Keys.Enter
                OpenFile()
                e.SuppressKeyPress = True
            Case = Keys.Escape : CloseForm()
        End Select
    End Sub
End Class