﻿Imports System.IO
Imports System.Net.Mail

Public Class frmEmailDaten

    Private _Attachments As New List(Of String)
    Private _Recipient As String
    Private _Mail As New MailMessage
    Public Property GetAttachments As List(Of String)
        Get
            Return _Attachments
        End Get
        Set
            _Attachments = Value
        End Set
    End Property
    Public WriteOnly Property SetRecipient() As String
        Set
            _Recipient = Value
        End Set
    End Property

    Private Sub FrmSendMail_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        LVAnhaenge.AutoResizeColumns(ColumnHeaderAutoResizeStyle.HeaderSize)
        If BSEmailAdresse.Current Is Nothing Then
            ShowAutoClosingMessageBox("Keine Emaildaten gespeichert.")
            Me.DialogResult = DialogResult.Cancel
        End If
        If _Recipient.IsNotEmpty Then TBEmpfaenger.Text = _Recipient
        TBBetreff.Select()
        If Not _Attachments Is Nothing Then
            For Each item In _Attachments
                LVAnhaenge.Items.Add(Path.GetFileName(_Attachments(_Attachments.Count - 1)))
            Next
        End If
    End Sub
    Private Sub frmNachrichtKeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyData
            Case = (Keys.Control Or Keys.Enter)
                ValidateMailDataAndSend()
            Case = Keys.Enter
                If Not Me.ActiveControl Is TBNachricht AndAlso Not Me.ActiveControl Is TBSignatur Then
                    SelectNextControl(Me.ActiveControl, True, True, True, True)
                End If
        End Select
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNMailversenden.Click, BTNabbrechen.Click, BTNAnhanghinzufuegen.Click, BTNAnhangloeschen.Click
        Select Case True
            Case sender Is BTNMailversenden : ValidateMailDataAndSend()
            Case sender Is BTNAnhanghinzufuegen : AddAttachment()
            Case sender Is BTNAnhangloeschen : DeleteAttachment()
        End Select
    End Sub
    Private Sub ValidateMailDataAndSend()
        Dim MailData As New MailDaten(BSEmailAdresse.At(Of DtsDaten.EmailAdresseRow), TBEmpfaenger.Text,
                                              TBBCC.Text, TBCC.Text, TBBetreff.Text, TBNachricht.Text, TBSignatur.Text, _Attachments)
        Dim MailAddressesCheck As Tuple(Of Boolean, String) = MailData.CheckForValidMailAddresses()
        If Not MailAddressesCheck.Item1 Then
            ShowAutoClosingMessageBox(MailAddressesCheck.Item2)
            Return
        End If

        Dim ContainsTextCheck = MailData.CheckForMailText
        If Not ContainsTextCheck.SubjectHasText Then
            If Not ShowMessageBoxAndAskUserYesOrNo($"Es wurde {ContainsTextCheck.SubjectErrorText} angegeben.
                Trotzdem senden?") Then Return
        End If
        If Not ContainsTextCheck.MessageHasText Then
            If Not ShowMessageBoxAndAskUserYesOrNo($"Es wurde {ContainsTextCheck.MessageErrorText} angegeben.
                Trotzdem senden?") Then Return
        End If

        MailData.AddSignatureToMessage()
        If MailSendenKlasse.TryToSendMail(MailData) Then Me.DialogResult = DialogResult.OK
    End Sub
    Private Sub AddAttachment()
        OFDAnhaenge.Filter = "Alle Dateien (*.*)|*.*"
        OFDAnhaenge.FilterIndex = 1
        If OFDAnhaenge.ShowDialog() = Windows.Forms.DialogResult.OK Then
            For Each File In _Attachments
                If File = OFDAnhaenge.FileName Then Return
            Next
            _Attachments.Add(OFDAnhaenge.FileName)
            LVAnhaenge.Items.Add(Path.GetFileName(_Attachments(_Attachments.Count - 1)))
        End If
    End Sub
    Private Sub DeleteAttachment()
        If LVAnhaenge.SelectedItems.Count = 0 Then Return
        For i = 0 To _Attachments.Count - 1
            If Path.GetFileName(_Attachments(i)) = LVAnhaenge.SelectedItems(0).SubItems(0).Text Then
                _Attachments.RemoveAt(i)
                Exit For
            End If
        Next
        LVAnhaenge.FocusedItem.Remove()
    End Sub
    Private Sub BSEmail_CurrentChanged(sender As Object, e As EventArgs) Handles BSEmailAdresse.CurrentChanged
        If BSEmailAdresse.Current Is Nothing Then Return
        Dim MailSettings = BSEmailAdresse.At(Of DtsDaten.EmailAdresseRow)
        If MailSettings.Signature.IsNotEmpty Then
            TBSignatur.Text = Environment.NewLine & MailSettings.Signature
        Else
            TBSignatur.Text = ""
        End If
    End Sub
End Class