﻿Public Class frmStatistikAuswertung
    Private _Dts As DtsDaten
    Private Sub frmEvaluation_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        If e.KeyData = Keys.Escape Then Me.Close()
    End Sub
    Private Sub frmStatistikAuswertung_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        _Dts = DirectCast(BSMain.DataSource, DtsDaten)
        If Not IncomesSaved() Then
            ShowMessageBox("Es wurden keine Einnahmen gespeichert.")
            Me.Close()
            Return
        End If
        SetComboBoxesItems()
        SetCurrentValuesForComboBoxes()
        FillDGVWithMonthlyEvaluation()
        Me.Location = New Point(100, 90)
    End Sub
    Private Function IncomesSaved() As Boolean
        If _Dts.Tageseinnahme.Count = 0 Then
            Return False
        Else
            Return True
        End If
    End Function
    Private Sub SetComboBoxesItems()
        Dim maxDate As Integer = Integer.Parse(_Dts.Tageseinnahme.Max(Function(x) x.Datum).ToString("yyyy"))
        Dim minDate As Integer = Integer.Parse(_Dts.Tageseinnahme.Min(Function(x) x.Datum).ToString("yyyy"))
        For i = maxDate To minDate Step -1
            CBJahr.Items.Add(i.ToString)
            CBVergleichsJahr.Items.Add(i.ToString)
        Next
        CBVergleichsJahr.Items.Add(Date.Parse("01.01." & minDate.ToString).AddYears(-1).Year.ToString)
    End Sub
    Private Sub SetCurrentValuesForComboBoxes()
        CBMonat.SelectedIndex = DateTime.Now.Month - 1
        CBJahr.Text = DateTime.Now.Year.ToString
        CBVergleichsJahr.Text = DateTime.Now.AddYears(-1).Year.ToString
    End Sub
    Private Sub FillDGVWithMonthlyEvaluation()
        If CBMonat.Text.IsEmpty Then Return
        If CBJahr.Text.IsEmpty Then Return
        If CBVergleichsJahr.Text.IsEmpty Then Return

        Dim Starttime = DateTime.Now
        Dim year = Integer.Parse(CBJahr.Text)
        Dim yearcomp = Integer.Parse(CBVergleichsJahr.Text)
        Dim month = CBMonat.SelectedIndex + 1
        Dim Numberofdays As Integer
        Dim Startdate = New Date(year, month, 1)
        Dim StartdateComp = New Date(yearcomp, month, 1)
        Dim groupcount = _Dts.Warengruppe.Count
        Dim NumberofdaysComp As Integer

        ClearDGV()

        Dim dailyIncomes(31, groupcount) As Double
        Dim dailyCustomers(31) As Integer
        GetDataSummariesMonth(Startdate, dailyIncomes, dailyCustomers, Numberofdays)
        Dim dailyIncomesComp(31, groupcount) As Double
        Dim dailyCustomersComp(31) As Integer
        GetDataSummariesMonth(StartdateComp, dailyIncomesComp, dailyCustomersComp, NumberofdaysComp)

        CreateDgvColumnsForMonth(dailyIncomes)
        Dim DGVColumnCount = DGVAuswertung.ColumnCount
        FormatDGV(DGVColumnCount)
        WriteMonthlyEvaluationToDGV(Startdate, dailyIncomes, dailyCustomers)
        DGVAuswertung.Rows.Add("%")
        Const SumRow = 31

        CompareMonth(dailyIncomes, dailyCustomers, dailyIncomesComp, dailyCustomersComp, groupcount, yearcomp, SumRow)
        WriteSalesPerCustomer(dailyIncomes(SumRow, groupcount), dailyCustomers(SumRow), 0)
        CustomerAverage(Numberofdays, dailyCustomers(SumRow), 1)
        WriteSalesPerCustomer(dailyIncomesComp(SumRow, groupcount), dailyCustomersComp(SumRow), DGVAuswertung.Rows.Count - 2)
        CustomerAverage(NumberofdaysComp, dailyCustomersComp(SumRow), DGVAuswertung.Rows.Count - 1)
        DGVAuswertung.Rows.Add()

        ChangeDGVAndFormSizes(DGVAuswertung.ColumnCount)
    End Sub
    Private Sub ClearDGV()
        With DGVAuswertung
            .Rows.Clear()
            For i As Integer = .ColumnCount - 1 To 0 Step -1
                .Columns.RemoveAt(i)
            Next i
        End With
    End Sub
    Private Sub GetDataSummariesMonth(startdate As Date, incomes(,) As Double, customers() As Integer, ByRef OpenedDays As Integer)
        Dim dt1 = startdate.AddMonths(1)
        Dim productGroups = _Dts.Warengruppe.ToArray
        Dim groupcount = productGroups.Length
        Dim WareGroupIncomes = From WGIncomeTBL In productGroups.SelectMany(Function(x) x.GetWarengruppeEinnahmeRows)
                               Let dt = WGIncomeTBL.TageseinnahmeRow.Datum
                               Where dt >= startdate AndAlso dt < dt1 Select WGIncomeTBL
        For Each rwWareGroupTBL In WareGroupIncomes
            Dim rwPG = rwWareGroupTBL.WarengruppeRow
            Dim day = rwWareGroupTBL.TageseinnahmeRow.Datum.Day
            Dim iProdGroup = Array.IndexOf(productGroups, rwPG)
            Dim income = rwWareGroupTBL.Warengruppeneinnahme / 100
            incomes(day - 1, iProdGroup) = income
            incomes(31, iProdGroup) += income
        Next
        For day = 0 To incomes.GetLength(0) - 1
            For iProdGroup = 0 To groupcount - 1
                incomes(day, groupcount) += incomes(day, iProdGroup)
            Next
        Next
        Dim Totalcustomers As Integer
        For Each rwIncome In _Dts.Tageseinnahme.Where(Function(x) x.Datum >= startdate AndAlso x.Datum < dt1)
            customers(rwIncome.Datum.Day - 1) += rwIncome.Kundenzahl
            Totalcustomers += rwIncome.Kundenzahl
        Next
        customers(31) = Totalcustomers
        For i = 0 To customers.Count - 1
            If customers(i) > 0 Then OpenedDays += 1
        Next
        OpenedDays -= 1
    End Sub
    Private Sub CreateDgvColumnsForMonth(ArrIncome(,) As Double)
        DGVAuswertung.Columns.Add("clmDate", "Datum")
        For Each rwPG In _Dts.Warengruppe
            DGVAuswertung.Columns.Add("clm" & rwPG.Name, rwPG.Name)
        Next
        With DGVAuswertung
            .Columns.Add("clmTotalIncome", "gesamt")
            .Columns.Add("clmCustomers", "Kunden")
            .Columns.Add("clmHeader", "")
            .Columns.Add("cmlpcs", "")
        End With
    End Sub
    Private Sub FormatDGV(DGVColumnCount As Integer)
        DGVAuswertung.DefaultCellStyle.Font = New Font("Microsoft Sans Serif", 12)
        For L = 1 To DGVColumnCount - 1
            With DGVAuswertung.Columns(L)
                .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
                .SortMode = DataGridViewColumnSortMode.NotSortable
            End With
        Next
        With DGVAuswertung.Columns(DGVColumnCount - 2)
            .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft
            .AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
            .SortMode = DataGridViewColumnSortMode.NotSortable
        End With
        With DGVAuswertung.Columns(0)
            .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            .AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
            .SortMode = DataGridViewColumnSortMode.NotSortable
        End With
        With DGVAuswertung.Columns(DGVColumnCount - 3)
            .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
            .SortMode = DataGridViewColumnSortMode.NotSortable
        End With
        With DGVAuswertung.ColumnHeadersDefaultCellStyle
            .Alignment = DataGridViewContentAlignment.MiddleCenter
            .Font = New Font("Microsoft Sans Serif", 12)
        End With
    End Sub
    Private Sub WriteMonthlyEvaluationToDGV(startDate As Date, ArrIncome(,) As Double, customersPerday() As Integer)
        Dim DGVColumnCount = DGVAuswertung.ColumnCount
        Dim groupcount = ArrIncome.GetLength(1) - 1
        Dim month = startDate.Month
        For day = 0 To 31
            Dim dt = startDate.AddDays(day)
            If dt.Month <> month Then Exit For
            Dim customers = customersPerday(day)
            If customers > 0 Then
                DGVAuswertung.Rows.Add(dt.ToString("ddd dd.MM"))
                Dim dgvRow = DGVAuswertung.Rows(DGVAuswertung.Rows.Count - 1)
                For i = 0 To groupcount
                    dgvRow.Cells(i + 1).Value = ArrIncome(day, i).ToString("#,##0.00")
                Next
                dgvRow.Cells(DGVColumnCount - 3).Value = customers
            End If
        Next
        DGVAuswertung.Rows.Add("")
        DGVAuswertung.Rows.Add("gesamt")
        For i = 0 To groupcount
            DGVAuswertung.Rows(DGVAuswertung.Rows.Count - 1).Cells(i + 1).Value = ArrIncome(31, i).ToString("#,##0.00")
        Next
        DGVAuswertung.Rows(DGVAuswertung.Rows.Count - 1).Cells(groupcount + 2).Value = customersPerday(31).ToString
    End Sub
    Private Sub CompareMonth(dailyIncomes(,) As Double, dailyCustomers() As Integer, dailyIncomesComp(,) As Double, dailyCustomersComp() As Integer,
                            groupcount As Integer, yearcomp As Integer, sumrow As Integer)
        Dim col = DGVAuswertung.Columns.Count - 3
        Dim WritingRow = DGVAuswertung.Rows.Count - 1
        For i = 0 To groupcount
            DGVAuswertung.Rows(WritingRow).Cells(i + 1).Value = Math.Round(((dailyIncomes(sumrow, i) - dailyIncomesComp(sumrow, i)) / dailyIncomesComp(sumrow, i)) * 100, 2).ToString("0.00") & " %"
        Next
        Dim Customercompare As Double = Math.Round(((dailyCustomers(sumrow) - dailyCustomersComp(sumrow)) / dailyCustomersComp(sumrow)) * 100, 2)
        DGVAuswertung.Rows(WritingRow).Cells(col).Value = Customercompare.ToString("0.00") & " %"
        If Customercompare > 0 Then
            With DGVAuswertung
                .Rows(WritingRow).Cells(col).Style.ForeColor = Color.Blue
                .Rows(WritingRow).Cells(col).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
                .Rows(WritingRow - 1).Cells(col).Style.ForeColor = Color.Blue
                .Rows(WritingRow - 1).Cells(col).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
            End With
        End If
        For i = 0 To groupcount
            If dailyIncomes(sumrow, i) > dailyIncomesComp(sumrow, i) Then
                With DGVAuswertung
                    .Rows(WritingRow).Cells(i + 1).Style.ForeColor = Color.Blue
                    .Rows(WritingRow).Cells(i + 1).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
                    .Rows(WritingRow - 1).Cells(i + 1).Style.ForeColor = Color.Blue
                    .Rows(WritingRow - 1).Cells(i + 1).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
                End With
            End If
        Next
        DGVAuswertung.Rows.Add()
        DGVAuswertung.Rows.Add(yearcomp.ToString)
        WritingRow += 2
        For i = 0 To groupcount
            DGVAuswertung.Rows(WritingRow).Cells(i + 1).Value = dailyIncomesComp(sumrow, i).ToString("#,##0.00")
        Next
        DGVAuswertung.Rows(WritingRow).Cells(col).Value = dailyCustomersComp(sumrow).ToString
    End Sub
    Private Sub WriteSalesPerCustomer(monthlyIncomes As Double, monthlyCustomers As Integer, writingrow As Integer)
        Dim SalesPerCustomer = 0.00
        If monthlyCustomers > 0 Then SalesPerCustomer = monthlyIncomes / monthlyCustomers
        CaptionedWriting(writingrow, "pro Kopf", SalesPerCustomer)
    End Sub
    Private Sub CaptionedWriting(row As Integer, caption As String, value As Double)
        Dim col = DGVAuswertung.Columns.Count - 2
        Dim writeCells = DGVAuswertung.Rows(row).Cells
        writeCells(col).Value = caption
        writeCells(col + 1).Value = value.ToString("0.00")
    End Sub
    Private Sub CustomerAverage(Numberofdays As Integer, monthlyCustomers As Integer, writingrow As Integer)
        Dim CustAvgComp As Double = 0
        If Numberofdays > 0 Then CustAvgComp = monthlyCustomers / Numberofdays
        CaptionedWriting(writingrow, "Kundenschnitt", CustAvgComp)
    End Sub
    Private Sub ChangeDGVAndFormSizes(DGVColumnCount As Integer)
        With DGVAuswertung
            .Width = .Columns.Cast(Of DataGridViewColumn).Sum(Function(x) x.Width) + 2
            .Height = .Rows.Cast(Of DataGridViewRow).Sum(Function(x) x.Height) + .ColumnHeadersHeight
            .Columns(DGVColumnCount - 1).AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
        End With

        Dim border As Integer = Integer.Parse(((Me.Size.Width - Me.ClientSize.Width) / 2).ToString)
        Dim header As Integer = Me.Size.Height - Me.ClientSize.Height - border
        Dim NewFormWidth = DGVAuswertung.Width + border * 2 + 30
        If NewFormWidth > 700 Then Me.Width = NewFormWidth
        Me.Height = DGVAuswertung.Height + border + header + 110
    End Sub
    Private Sub FillDGVWithYearlyEvaluation()
        If CBJahr.Text.IsEmpty Then Return
        If CBVergleichsJahr.Text.IsEmpty Then Return
        Dim Year = Integer.Parse(CBJahr.Text)
        Dim yearComp = Integer.Parse(CBVergleichsJahr.Text)

        Dim groupcount = _Dts.Warengruppe.Count
        ClearDGV()
        DrawDGVColumnsForYear(groupcount)

        Dim ArrIncome(0 To 12, 0 To groupcount) As Double
        Dim ArrCustomers(0 To 11) As Integer
        GetDataSummariesYear(Year, ArrIncome, ArrCustomers)
        WriteMonthlySalesToDGV(ArrIncome, ArrCustomers)
        Dim CustomersTotal = ArrCustomers.Sum
        WriteYearlySalesToDGV(CustomersTotal, ArrIncome, summaryRow:=13)

        Dim ArrIncomeComp(0 To 12, 0 To groupcount) As Double
        Dim ArrCustomersComp(0 To 11) As Integer
        GetDataSummariesYear(yearComp, ArrIncomeComp, ArrCustomersComp)
        DGVAuswertung.Rows.Add("")
        DGVAuswertung.Rows.Add(yearComp.ToString)
        Dim CustomersTotalComp = ArrCustomersComp.Sum
        WriteYearlySalesToDGV(CustomersTotalComp, ArrIncomeComp, summaryRow:=16)

        Dim DGVColumnCount = DGVAuswertung.ColumnCount
        CompareYears(DGVColumnCount, CustomersTotal, CustomersTotalComp, groupcount, ArrIncome, ArrIncomeComp, ArrCustomers, ArrCustomersComp)

        FormatDGV(DGVColumnCount)

        ChangeDGVAndFormSizes(DGVColumnCount)
    End Sub
    Private Sub DrawDGVColumnsForYear(groupcount As Integer)
        DGVAuswertung.Columns.Add("clmDate", "Datum")
        Dim Groupname As String
        For i = 0 To groupcount - 1
            Dim ProductGroup = DirectCast(DirectCast(BSWarengruppe(i), DataRowView).Row, DtsDaten.WarengruppeRow)
            Groupname = ProductGroup.Name
            DGVAuswertung.Columns.Add("clm" & Groupname, Groupname)
        Next
        With DGVAuswertung
            .Columns.Add("clmTotalIncome", "gesamt")
            .Columns.Add("clmCustomers", "Kunden")
            .Rows.Add("Januar")
            .Rows.Add("Februar")
            .Rows.Add("März")
            .Rows.Add("April")
            .Rows.Add("Mai")
            .Rows.Add("Juni")
            .Rows.Add("Juli")
            .Rows.Add("August")
            .Rows.Add("September")
            .Rows.Add("Oktober")
            .Rows.Add("November")
            .Rows.Add("Dezember")
            .Rows.Add("")
            .Rows.Add("gesamt")
            .Rows.Add("%")
        End With
    End Sub
    Private Sub GetDataSummariesYear(year As Integer, ArrIncome(,) As Double, customersPerMonth() As Integer)
        Dim dt0 = New Date(year, 1, 1), dt1 = dt0.AddYears(1)
        Dim productGroups = _Dts.Warengruppe.ToArray
        Dim groupcount = productGroups.Length
        Dim WareGroupIncomes = From waregrouptbl In productGroups.SelectMany(Function(x) x.GetWarengruppeEinnahmeRows)
                               Let dt = waregrouptbl.TageseinnahmeRow.Datum
                               Where dt >= dt0 AndAlso dt < dt1 Select waregrouptbl
        For Each rwWareGroupIncomes In WareGroupIncomes
            Dim rwPG = rwWareGroupIncomes.WarengruppeRow
            Dim month = rwWareGroupIncomes.TageseinnahmeRow.Datum.Month
            Dim iProdGroup = Array.IndexOf(productGroups, rwPG)
            ArrIncome(month - 1, iProdGroup) += CDbl(rwWareGroupIncomes.Warengruppeneinnahme / 100)
            ArrIncome(12, iProdGroup) += CDbl(rwWareGroupIncomes.Warengruppeneinnahme / 100)
        Next
        For Each rwIncome In _Dts.Tageseinnahme.Where(Function(x) x.Datum >= dt0 AndAlso x.Datum < dt1)
            customersPerMonth(rwIncome.Datum.Month - 1) += rwIncome.Kundenzahl
        Next
        For month = 0 To 12
            For iProdGroup = 0 To groupcount - 1
                ArrIncome(month, groupcount) += ArrIncome(month, iProdGroup)
            Next
        Next
    End Sub
    Private Sub WriteMonthlySalesToDGV(ArrIncome(,) As Double, customersPerMonth() As Integer)
        Dim DGVColumnCount = DGVAuswertung.ColumnCount
        Dim groupcount = ArrIncome.GetLength(1) - 1
        For Monat = 1 To 12
            For i = 0 To groupcount
                DGVAuswertung.Rows(Monat - 1).Cells(i + 1).Value = ArrIncome(Monat - 1, i).ToString("#,##0.00")
            Next
            DGVAuswertung.Rows(Monat - 1).Cells(DGVColumnCount - 1).Value = customersPerMonth(Monat - 1).ToString
        Next
    End Sub
    Private Sub WriteYearlySalesToDGV(Customerstotal As Integer, ArrIncome(,) As Double, summaryRow As Integer)
        Dim DGVColumnCount = DGVAuswertung.ColumnCount
        Dim groupcount = ArrIncome.GetLength(1) - 1
        For i = 0 To groupcount
            DGVAuswertung.Rows(summaryRow).Cells(i + 1).Value = ArrIncome(12, i).ToString("#,##0.00")
        Next
        DGVAuswertung.Rows(summaryRow).Cells(DGVColumnCount - 1).Value = Customerstotal.ToString
    End Sub
    Private Sub CompareYears(DGVColumnCount As Integer, CustomersTotal As Integer, CustomersTotalComp As Integer, groupcount As Integer,
                             arrIncome(,) As Double, arrIncomeComp(,) As Double, arrCustomers() As Integer, arrCustomersComp() As Integer)
        DGVAuswertung.Rows(14).Cells(DGVColumnCount - 1).Value = Math.Round(((CustomersTotal - CustomersTotalComp) / CustomersTotalComp) * 100, 2).ToString("0.00") & " %"
        For i = 0 To groupcount
            DGVAuswertung.Rows(14).Cells(i + 1).Value = Math.Round(((arrIncome(12, i) - arrIncomeComp(12, i)) / arrIncomeComp(12, i)) * 100, 2).ToString("0.00") & " %"
        Next
        If CustomersTotal > CustomersTotalComp Then
            For i = 13 To 14
                With DGVAuswertung
                    .Rows(i).Cells(DGVColumnCount - 1).Style.ForeColor = Color.Blue
                    .Rows(i).Cells(DGVColumnCount - 1).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
                End With
            Next
        End If
        For i = 0 To groupcount
            If arrIncome(12, i) > arrIncomeComp(12, i) Then
                For j = 13 To 14
                    With DGVAuswertung
                        .Rows(j).Cells(i + 1).Style.ForeColor = Color.Blue
                        .Rows(j).Cells(i + 1).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
                    End With
                Next
            End If
        Next
        For i = 0 To 11
            For j = 0 To groupcount
                If arrIncome(i, j) > arrIncomeComp(i, j) Then
                    With DGVAuswertung
                        .Rows(i).Cells(j + 1).Style.ForeColor = Color.Blue
                        .Rows(i).Cells(j + 1).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
                    End With
                End If
            Next
        Next
        For i = 0 To 11
            If arrCustomers(i) > arrCustomersComp(i) Then
                With DGVAuswertung
                    .Rows(i).Cells(DGVColumnCount - 1).Style.ForeColor = Color.Blue
                    .Rows(i).Cells(DGVColumnCount - 1).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
                End With
            End If
        Next
    End Sub
    Private Sub CBJahr_TextChanged(sender As Object, e As EventArgs) Handles CBJahr.TextChanged
        Dim Year As Integer
        If Integer.TryParse(CBJahr.Text, Year) Then CBVergleichsJahr.Text = (Year - 1).ToString
    End Sub
    Private Sub DGVAuswertung_Click(sender As Object, e As EventArgs) Handles DGVAuswertung.Click
        Dim amount As Double
        Dim result As Double
        For Each cell As DataGridViewCell In DGVAuswertung.SelectedCells
            If Not cell.Value Is Nothing AndAlso Double.TryParse(cell.Value.ToString, result) Then
                amount += result
            End If
        Next
        LBLSumme.Text = amount.ToString("#,##0.00")
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNVergleichsJahrPlus.Click, BTNVergleichsJahrMinus.Click,
        BTNMonatPlus.Click, BTNMonatMinus.Click, BTNMonatsAuswertung.Click, BTNJahrPlus.Click, BTNJahrMinus.Click, BTNJahresAuswertung.Click
        Select Case True
            Case sender Is BTNVergleichsJahrPlus : CBVergleichsJahr.Text = ChangeYear(1, CBVergleichsJahr.Text)
            Case sender Is BTNVergleichsJahrMinus : CBVergleichsJahr.Text = ChangeYear(-1, CBVergleichsJahr.Text)
            Case sender Is BTNJahrPlus : CBJahr.Text = ChangeYear(1, CBJahr.Text)
            Case sender Is BTNJahrMinus : CBJahr.Text = ChangeYear(-1, CBJahr.Text)
            Case sender Is BTNMonatPlus : CBMonat.SelectedIndex = ChangeMonthIndex(1)
            Case sender Is BTNMonatMinus : CBMonat.SelectedIndex = ChangeMonthIndex(-1)
            Case sender Is BTNMonatsAuswertung : FillDGVWithMonthlyEvaluation()
            Case sender Is BTNJahresAuswertung : FillDGVWithYearlyEvaluation()
        End Select
    End Sub
    Private Function ChangeYear(Change As Integer, year As String) As String
        Dim CurrentYear = Integer.Parse(year)
        CurrentYear += Change
        Return CurrentYear.ToString
    End Function
    Private Function ChangeMonthIndex(change As Integer) As Integer
        Dim Index As Integer = CBMonat.SelectedIndex
        Index += change
        Select Case Index
            Case <= -1 : Index = 11
            Case = 12 : Index = 0
        End Select
        Return Index
    End Function
End Class