﻿Public Class frmStatistikRekorde
    Private _Dts As DtsDaten
    Private Sub frmStatistikRekorde_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        If e.KeyData = Keys.Escape Then Me.Close()
    End Sub
    Private Sub frmStatistikRekorde_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        _Dts = DirectCast(BSMain.DataSource, DtsDaten)
        If _Dts.Tageseinnahme.Rows.Count > 0 Then
            WriteDailyRecords()
            WriteMonthlyRecords()
        End If
    End Sub
    Private Sub WriteDailyRecords()
        Dim yPosition As Integer = 60
        Dim LBLLabelIncome = CreateLabel(5, yPosition, New Size(200, 20), "Tageseinnahme")
        Dim incomeRekord = _Dts.IncomeRecord
        Dim LBLRecordIncome = CreateLabel(210, yPosition, New Size(120, 20), (incomeRekord.Tageseinnahme / 100).ToString("#,##0.00"))
        Dim LBLRecordIncomeDate = CreateLabel(340, yPosition, New Size(150, 20), incomeRekord.Datum.ToShortDateString)
        Me.Controls.Add(LBLLabelIncome)
        Me.Controls.Add(LBLRecordIncome)
        Me.Controls.Add(LBLRecordIncomeDate)

        yPosition += 30
        Dim LBLLabelCustomers = CreateLabel(5, yPosition, New Size(200, 20), "Kunden")
        Dim custRecord = _Dts.CustomersRecord
        Dim LBLRecordCustomers = CreateLabel(210, yPosition, New Size(120, 20), custRecord.Kundenzahl.ToString)
        Dim LBLRecordCustomersDate = CreateLabel(340, yPosition, New Size(150, 20), custRecord.Datum.ToShortDateString)
        Me.Controls.Add(LBLLabelCustomers)
        Me.Controls.Add(LBLRecordCustomers)
        Me.Controls.Add(LBLRecordCustomersDate)

        yPosition += 80
        For Each record In _Dts.ProductGroupRecords
            Dim ParentProductGroupRow = record.WarengruppeRow
            Dim ParentDailyIncomeRow = record.TageseinnahmeRow
            Dim RecordDate = ParentDailyIncomeRow.Datum
            Dim ProductGroupName = ParentProductGroupRow.Name
            Dim ProductGroupIncome = record.Warengruppeneinnahme / 100
            Dim LBLLabelProductGroup = CreateLabel(5, yPosition, New Size(200, 20), ProductGroupName)
            Dim LBLRecordProductGroup = CreateLabel(210, yPosition, New Size(120, 20), ProductGroupIncome.ToString("#,##0.00"))
            Dim LBLRecordProductGroupDate = CreateLabel(340, yPosition, New Size(150, 20), RecordDate.ToShortDateString)
            Me.Controls.Add(LBLLabelProductGroup)
            Me.Controls.Add(LBLRecordProductGroup)
            Me.Controls.Add(LBLRecordProductGroupDate)
            yPosition += 30
        Next
        SetFormSize(yPosition)
    End Sub
    Private Sub WriteMonthlyRecords()
        Dim GroupCount = _Dts.Warengruppe.Count
        If GroupCount = 0 Then Return
        If _Dts.Tageseinnahme.Count = 0 Then Return

        Dim yPosition = 60
        Dim LBLLabelIncome = CreateLabel(490, yPosition, New Size(200, 20), "Monatseinnahme")
        Dim LBLRecordIncome = CreateLabel(700, yPosition, New Size(120, 20), (_Dts.MonthlyIncomeRecord.Item2 / 100).ToString("#,##0.00 €"))
        Dim LBLRecordIncomeDate = CreateLabel(830, yPosition, New Size(150, 20), $"im {_Dts.MonthlyIncomeRecord.Item1:MMMM yyyy}")
        Me.Controls.Add(LBLLabelIncome)
        Me.Controls.Add(LBLRecordIncome)
        Me.Controls.Add(LBLRecordIncomeDate)

        yPosition += 30
        Dim LBLLabelCustomers = CreateLabel(490, yPosition, New Size(200, 20), "Kunden")
        Dim LBLRecordCustomers = CreateLabel(700, yPosition, New Size(120, 20), _Dts.MonthlyCustomersRecord.Item2.ToString)
        Dim LBLRecordCustomersDate = CreateLabel(830, yPosition, New Size(150, 20), $"im {_Dts.MonthlyCustomersRecord.Item1:MMMM yyyy}")
        Me.Controls.Add(LBLLabelCustomers)
        Me.Controls.Add(LBLRecordCustomers)
        Me.Controls.Add(LBLRecordCustomersDate)

        yPosition += 30
        Dim LBLLabelPCS = CreateLabel(490, yPosition, New Size(200, 20), "pro Kopf Umsatz")
        Dim LBLRecordPCS = CreateLabel(700, yPosition, New Size(120, 20), _Dts.PCSRecord.Item2.ToString("#,##0.00 €"))
        Dim LBLRecordPCSDate = CreateLabel(830, yPosition, New Size(150, 20), $"im {_Dts.PCSRecord.Item1:MMMM yyyy}")
        Me.Controls.Add(LBLLabelPCS)
        Me.Controls.Add(LBLRecordPCS)
        Me.Controls.Add(LBLRecordPCSDate)

        yPosition += 50
        For Each tpl In _Dts.MonthlyGroupRecords
            Dim LBLName = CreateLabel(490, yPosition, New Size(200, 20), tpl.Item2.Name)
            Dim LBLRecord = CreateLabel(700, yPosition, New Size(120, 20), (tpl.Item3 / 100).ToString("#,##0.00 €"))
            Dim LBLRecordDate = CreateLabel(830, yPosition, New Size(150, 20), $"im {tpl.Item1:MMMM yyyy}")
            Me.Controls.Add(LBLName)
            Me.Controls.Add(LBLRecord)
            Me.Controls.Add(LBLRecordDate)
            yPosition += 30
        Next
    End Sub
    Private Function CreateLabel(xPosition As Integer, yPosition As Integer, LabelSize As Size, LBLText As String) As Label
        Dim LBLLabel = New System.Windows.Forms.Label
        With LBLLabel
            .Location = New Point(xPosition, yPosition)
            .Font = New Font("Microsoft Sans Serif", 12)
            .TextAlign = ContentAlignment.MiddleRight
            .Size = LabelSize
            .Text = LBLText
            .Visible = True
        End With
        Return LBLLabel
    End Function
    Private Sub SetFormSize(yPosition As Integer)
        Dim border As Integer = Integer.Parse(((Me.Size.Width - Me.ClientSize.Width) / 2).ToString)
        Dim header As Integer = Me.Size.Height - Me.ClientSize.Height - border
        Me.Height = yPosition + 20 + border + header
    End Sub
End Class