﻿Public Class frmneueEinnahme
    Private _Dts As DtsDaten
    Private _TBWaregroupList As New List(Of TextBox)
    Private _CurrentTBIndex As Integer = -1
    Private _FormHeight As Integer
    Private _KeyboardVisible As Boolean

    Private Sub frmNewIncome_Paint(sender As Object, e As PaintEventArgs) Handles Me.Paint
        e.Graphics.DrawLine(Pens.Black, 2, 175, 730, 175)
    End Sub
    Private Sub frmneueEinnahme_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        _Dts = DirectCast(BSMain.DataSource, DtsDaten)
        DTPDatum.Value = DateTime.Now
        Me.PanKeyboard.Visible = False
        DrawControls()
        LoadIncomeData()
        RegisterNumericTextboxInput(_TBWaregroupList.ToArray)
        RegisterNumericTextboxInput(TBKundenzahl)
    End Sub
    Private Sub DrawControls()
        Dim AmountOfProductGroups = _Dts.Warengruppe.Count
        If AmountOfProductGroups = 0 Then
            ShowAutoClosingMessageBox("Eintragen nicht möglich. - keine Warengruppen gespeichert.")
            Me.Close()
            Return
        End If

        Dim GroupName As String
        Dim yPosition As Integer = 190
        Dim xPosition As Integer = 12
        For i = 1 To AmountOfProductGroups
            Dim ProductGroup = DirectCast(DirectCast(BSWarengruppe(i - 1), DataRowView).Row, DtsDaten.WarengruppeRow)
            GroupName = ProductGroup.Name
            Dim LBLWareGroupHeader = CreateWGHeaderLabel(xPosition, yPosition, GroupName)
            Dim TBWareGroupIncome = CreateNewWGTextbox(xPosition, yPosition, GroupName, i)
            Me.Controls.Add(LBLWareGroupHeader)
            Me.Controls.Add(TBWareGroupIncome)

            xPosition += 250
            If xPosition > 532 Then
                xPosition = 12
                yPosition += 70
            End If
        Next
        If xPosition = 12 Then yPosition -= 70
        Me.Height = yPosition + 140
        _FormHeight = Me.Height
    End Sub
    Private Function CreateWGHeaderLabel(xPosition As Integer, yPosition As Integer, Groupname As String) As Label
        Dim NewLBL = New Label
        With NewLBL
            .Location = New System.Drawing.Point(xPosition, yPosition)
            .Font = New Font("Microsoft Sans Serif", 12)
            .TextAlign = ContentAlignment.MiddleCenter
            .Name = "LBL " & Groupname
            .Size = New System.Drawing.Size(200, 20)
            .Text = Groupname
            .Visible = True
        End With
        Return NewLBL
    End Function
    Private Function CreateNewWGTextbox(xPosition As Integer, yPosition As Integer, Groupname As String, i As Integer) As TextBox
        Dim newTB = New System.Windows.Forms.TextBox
        With newTB
            .Location = New System.Drawing.Point(xPosition, yPosition + 23)
            .Font = New Font("Microsoft Sans Serif", 12)
            .Name = "TB " & Groupname
            .Size = New System.Drawing.Size(200, 26)
            .TabIndex = i + 1
            .Visible = True
            AddHandler .TextChanged, AddressOf TextBox_TextChangeEvent
            AddHandler .Enter, AddressOf TextBox_Enter
        End With
        _TBWaregroupList.Add(newTB)
        Return newTB
    End Function
    Private Sub TextBox_TextChangeEvent(sender As Object, e As EventArgs)
        Dim TBContent As String
        Dim TotalIncome As Double = 0
        Dim Income As Double
        For Each TB As Control In _TBWaregroupList
            TBContent = TB.Text
            If TBContent.IsEmpty Then TBContent = "0"
            Double.TryParse(TBContent, Income)
            TotalIncome += Income
            LBLTageseinnahme.Text = TotalIncome.ToString("#,##0.00")
        Next
    End Sub
    Private Sub TextBox_Enter(sender As Object, e As EventArgs)
        Dim SelectedTextBox = DirectCast(sender, TextBox)
        For i = 0 To _TBWaregroupList.Count - 1
            If _TBWaregroupList(i) Is SelectedTextBox Then _CurrentTBIndex = i
        Next
    End Sub
    Private Sub LoadIncomeData()
        ClearTextBoxes()
        Dim IncomeRow = LoadIncomeRow(DTPDatum.Value.Date)
        If IncomeRow Is Nothing Then Return
        WriteIncomeData(IncomeRow, DTPDatum.Value.Date)
    End Sub
    Private Sub ClearTextBoxes()
        For Each TB As Control In _TBWaregroupList
            TB.Text = ""
        Next
        TBKundenzahl.Text = ""
        LBLTageseinnahme.Text = ""
    End Sub
    Private Function LoadIncomeRow(IncomdeDate As Date) As DtsDaten.TageseinnahmeRow
        Return _Dts.Tageseinnahme.FirstOrDefault(Function(x) x.Datum = IncomdeDate)
    End Function
    Private Sub WriteIncomeData(IncomeRow As DtsDaten.TageseinnahmeRow, IncomeDate As Date)
        TBKundenzahl.Text = IncomeRow.Kundenzahl.ToString
        LBLTageseinnahme.Text = (IncomeRow.Tageseinnahme / 100).ToString
        For Each TB As Control In _TBWaregroupList
            Dim Groupname As String = TB.Name.Substring(3)
            Dim ProductGroupIncomeRow = _Dts.WarengruppeEinnahme.SingleOrDefault(Function(x) x.TageseinnahmeRow.Datum = IncomeDate AndAlso x.WarengruppeRow.Name = Groupname)
            If ProductGroupIncomeRow Is Nothing Then Return
            TB.Text = (ProductGroupIncomeRow.Warengruppeneinnahme / 100).ToString
        Next
    End Sub
    Private Sub dlgAdresseBearbeiten_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        Select Case e.KeyData
            Case = Keys.Escape : Me.Close()
            Case = Keys.Enter
                ProccessEnterKeyPress()
                e.SuppressKeyPress = True
        End Select
    End Sub
    Private Sub ProccessEnterKeyPress()
        _CurrentTBIndex += 1
        If _TBWaregroupList.Count > _CurrentTBIndex Then
            _TBWaregroupList(_CurrentTBIndex).Select()
        ElseIf _TBWaregroupList.Count = _CurrentTBIndex Then
            BTNSpeichern.Select()
        Else
            ValidateUserInputAndSaveIncome()
        End If
    End Sub
    Private Sub DTPDatum_CloseUp(sender As Object, e As EventArgs) Handles DTPDatum.CloseUp
        TBKundenzahl.SelectionStart = TBKundenzahl.Text.Length
    End Sub
    Private Sub DTPDatum_ValueChanged(sender As Object, e As EventArgs) Handles DTPDatum.ValueChanged
        LoadIncomeData()
    End Sub
    Private Sub TBKundenzahl_Enter(sender As Object, e As EventArgs) Handles TBKundenzahl.Enter
        _CurrentTBIndex = -1
    End Sub
    Private Sub BTNTop_Click(sender As Object, e As EventArgs) Handles BTNTastatur.Click, BTNTagPlus.Click, BTNTagMinus.Click, BTNSpeichern.Click, BTNSchliessen.Click, BTNLoeschen.Click
        Select Case True
            Case sender Is BTNTagPlus : SetNewDate(1)
            Case sender Is BTNTagMinus : SetNewDate(-1)
            Case sender Is BTNTastatur : ShowOrHideKeyboard()
            Case sender Is BTNSchliessen : Me.Close()
            Case sender Is BTNSpeichern : ValidateUserInputAndSaveIncome()
            Case sender Is BTNLoeschen : DeleteIncome()
        End Select
    End Sub
    Private Sub SetNewDate(DateChange As Integer)
        If DTPDatum.Value.AddDays(DateChange).DayOfWeek = 0 Then
            DTPDatum.Value = DTPDatum.Value.AddDays(DateChange * 2)
        Else
            DTPDatum.Value = DTPDatum.Value.AddDays(DateChange)
        End If
    End Sub
    Private Sub ShowOrHideKeyboard()
        If _KeyboardVisible Then
            _FormHeight -= 330
        Else
            _FormHeight += 330
            Me.PanKeyboard.Location = New Point(0, _FormHeight - 375)
        End If
        _KeyboardVisible = Not _KeyboardVisible
        PanKeyboard.Visible = _KeyboardVisible
        Me.Height = _FormHeight
    End Sub
    Private Sub ValidateUserInputAndSaveIncome()
        Dim CheckUserInput = ValidateUserInput()
        If Not CheckUserInput.UserInputCorrect Then
            ShowAutoClosingMessageBox(CheckUserInput.ErrorText)
            Return
        End If
        SaveIncome()
    End Sub
    Private Function ValidateUserInput() As (UserInputCorrect As Boolean, ErrorText As String)
        Dim TempInteger As Integer
        Dim TempDouble As Double
        If Not Integer.TryParse(TBKundenzahl.Text, TempInteger) Then Return (False, "Kundenzahl ungültig")
        For Each TB As Control In _TBWaregroupList
            If TB.Text.IsEmpty Then
                TB.Text = "0"
            Else
                If Not Double.TryParse(TB.Text, TempDouble) Then Return (False, $"{TB.Name.Substring(3)} Einnahme ungültig")
            End If
        Next
        Return (True, "")
    End Function
    Private Sub SaveIncome()
        Dim IncomeDate = DTPDatum.Value.Date
        Dim IncomeRow = LoadIncomeRow(IncomeDate)

        If IncomeRow Is Nothing Then
            CreateNewIncome(IncomeDate)
        Else
            EditExistingIncome(IncomeRow, IncomeDate)
        End If
        CheckForNewStatisticRecords(IncomeDate)

        If CBXMehrereEintraege.Checked Then
            SetNewDate(1)
            TBKundenzahl.Focus()
        Else
            Me.Close()
        End If
    End Sub
    Private Sub CheckForNewStatisticRecords(IncomeDate As Date)
        Dim ArrDailyGroupincome(0 To _TBWaregroupList.Count - 1) As Double
        Dim i = -1
        For Each TB As Control In _TBWaregroupList
            i = i + 1
            ArrDailyGroupincome(i) = Double.Parse(TB.Text)
        Next
        _Dts.FindNewStatisticRecordsDaily(Integer.Parse(TBKundenzahl.Text), Double.Parse(LBLTageseinnahme.Text), ArrDailyGroupincome, IncomeDate)
        _Dts.FindNewStatisticRecordsMonthly(IncomeDate)
    End Sub
    Private Sub CreateNewIncome(IncomeDate As Date)
        Dim DailyIncomeRow = AddDailyIncomeRow(IncomeDate)

        For Each TB In _TBWaregroupList
            Dim ProductGroupRow = SearchProductGroupRow(TB)
            If ProductGroupRow.row Is Nothing Then
                ShowAutoClosingMessageBox($"Die Warengruppe {ProductGroupRow.row.Name} existiert nicht.")
            End If
            CreateNewWareGroupIncome(ProductGroupRow.row, ProductGroupRow.Income, DailyIncomeRow)
        Next
    End Sub
    Private Function AddDailyIncomeRow(Incomedate As Date) As DtsDaten.TageseinnahmeRow
        Dim newIncome As DtsDaten.TageseinnahmeRow
        newIncome = _Dts.Tageseinnahme.NewTageseinnahmeRow()
        With newIncome
            .Datum = Incomedate
            .Kundenzahl = Integer.Parse(TBKundenzahl.Text)
            .Tageseinnahme = CInt(Double.Parse(LBLTageseinnahme.Text) * 100)
        End With
        _Dts.Tageseinnahme.Rows.Add(newIncome)
        Return newIncome
    End Function
    Private Function SearchProductGroupRow(TB As TextBox) As (row As DtsDaten.WarengruppeRow, Income As Integer)
        Dim ProductGroupIncome As Integer
        ProductGroupIncome = CInt(Double.Parse(TB.Text) * 100)
        Dim ProductGroup = _Dts.Warengruppe
        For Each row In ProductGroup
            If "TB " & row.Name = TB.Name Then
                Return (row, ProductGroupIncome)
                Exit For
            End If
        Next
        Return Nothing
    End Function
    Private Sub CreateNewWareGroupIncome(ProductGroupRow As DtsDaten.WarengruppeRow, ProductGroupIncome As Integer,
                                         DailyIncomeRow As DtsDaten.TageseinnahmeRow)
        Dim newDistributionRow As DtsDaten.WarengruppeEinnahmeRow
        newDistributionRow = _Dts.WarengruppeEinnahme.NewWarengruppeEinnahmeRow()
        With newDistributionRow
            .WarengruppeRow = ProductGroupRow
            .TageseinnahmeRow = DailyIncomeRow
            .Warengruppeneinnahme = ProductGroupIncome
        End With
        _Dts.WarengruppeEinnahme.Rows.Add(newDistributionRow)
    End Sub
    Private Sub EditExistingIncome(IncomeRow As DtsDaten.TageseinnahmeRow, IncomeDate As Date)
        Dim DailyIncomeRow = SaveCustomerCountAndDailyIncome(IncomeRow)

        For Each TB In _TBWaregroupList
            Dim ProductGroupRow = SearchProductGroupRow(TB)
            If ProductGroupRow.row Is Nothing Then
                CreateNewWareGroupIncome(ProductGroupRow.row, ProductGroupRow.Income, DailyIncomeRow)
            Else
                Dim ProductGroupIncomeRow = _Dts.WarengruppeEinnahme.SingleOrDefault(Function(x) x.TageseinnahmeRow.Datum = IncomeDate AndAlso x.WarengruppeRow.Name = TB.Name.Substring(3))
                If ProductGroupIncomeRow Is Nothing Then
                    CreateNewWareGroupIncome(ProductGroupRow.row, ProductGroupRow.Income, DailyIncomeRow)
                Else
                    ProductGroupIncomeRow.Warengruppeneinnahme = CInt(Double.Parse(TB.Text) * 100)
                End If
            End If
        Next
    End Sub
    Private Function SaveCustomerCountAndDailyIncome(IncomeRow As DtsDaten.TageseinnahmeRow) As DtsDaten.TageseinnahmeRow
        IncomeRow.Kundenzahl = Integer.Parse(TBKundenzahl.Text)
        IncomeRow.Tageseinnahme = CInt(Double.Parse(LBLTageseinnahme.Text) * 100)
        Return IncomeRow
    End Function
    Private Sub DeleteIncome()
        If ShowMessageBoxAndAskUserYesOrNo($"Die Einnahme vom {DTPDatum.Value.Date} wird gelöscht.{Environment.NewLine}Sind sie sicher?") Then
            Dim IncomeRow = _Dts.Tageseinnahme.FirstOrDefault(Function(x) x.Datum = DTPDatum.Value.Date)
            Dim IncomeDate = DTPDatum.Value.Date
            If Not IncomeRow Is Nothing Then
                IncomeRow.Delete()
                TBKundenzahl.Text = ""
                For Each TB In _TBWaregroupList
                    TB.Text = ""
                Next
            End If
        End If
    End Sub

    Private Sub BTNNumPad_Click(sender As Object, e As EventArgs) Handles BTNKomma.Click, BTNEnter.Click, BTNBackspace.Click, BTN9.Click, BTN8.Click, BTN7.Click, BTN6.Click, BTN5.Click, BTN4.Click, BTN3.Click, BTN2.Click, BTN1.Click, BTN00.Click, BTN0.Click
        Select Case True
            Case sender Is BTN00 : AddNumberToSelectedTB("00")
            Case sender Is BTN0 : AddNumberToSelectedTB("0")
            Case sender Is BTN1 : AddNumberToSelectedTB("1")
            Case sender Is BTN2 : AddNumberToSelectedTB("2")
            Case sender Is BTN3 : AddNumberToSelectedTB("3")
            Case sender Is BTN4 : AddNumberToSelectedTB("4")
            Case sender Is BTN5 : AddNumberToSelectedTB("5")
            Case sender Is BTN6 : AddNumberToSelectedTB("6")
            Case sender Is BTN7 : AddNumberToSelectedTB("7")
            Case sender Is BTN8 : AddNumberToSelectedTB("8")
            Case sender Is BTN9 : AddNumberToSelectedTB("9")
            Case sender Is BTNKomma : AddCommaToSelectedTB()
            Case sender Is BTNBackspace : AddBackspaceToSelectedTB()
            Case sender Is BTNEnter : ProccessEnterKeyPress()
        End Select
    End Sub
    Private Sub AddNumberToSelectedTB(Number As String)
        If _CurrentTBIndex = -1 Then
            TBKundenzahl.Text &= Number
        Else
            _TBWaregroupList(_CurrentTBIndex).Text &= Number
        End If
    End Sub
    Private Sub AddCommaToSelectedTB()
        If _CurrentTBIndex = -1 Then Return
        If Not _TBWaregroupList(_CurrentTBIndex).Text.Contains(",") Then _TBWaregroupList(_CurrentTBIndex).Text &= ","
    End Sub
    Private Sub AddBackspaceToSelectedTB()
        If _CurrentTBIndex = -1 Then
            If TBKundenzahl.Text.Length > 0 Then TBKundenzahl.Text = (TBKundenzahl.Text.Substring(0, TBKundenzahl.Text.Length - 1))
        Else
            If _TBWaregroupList(_CurrentTBIndex).Text.Length > 0 Then _TBWaregroupList(_CurrentTBIndex).Text = (_TBWaregroupList(_CurrentTBIndex).Text.Substring(0, (_TBWaregroupList(_CurrentTBIndex)).Text.Length - 1))
        End If
    End Sub

End Class