﻿Public Class BildenDesArtikelSuchString
    Private _Searchtext As String
    Private _Asterisk As String
    Private _SearchArtNo As Boolean
    Private _SearchEAN As Boolean
    Private _SearchName As Boolean
    Private _SearchNameAddition As Boolean
    Private _SearchPurchasingPrice As Boolean
    Private _SearchDiscount As Boolean
    Private _SearchListPrice As Boolean
    Private _SearchSalesMargin As Boolean
    Private _SearchRetailPrice As Boolean
    Private _SearchNote As Boolean
    Private _SearchExpiring As Boolean
    Private _SearchRetailPriceChanged As Boolean
    Private _RetailPriceChangedStartDate As String
    Private _RetailPriceChangedEndDate As String
    Private _SearchPurchasingPriceChanged As Boolean
    Private _PurchasingPriceChangedStartDate As String
    Private _PurchasingPriceChangedEndDate As String

    Public Sub New(Searchtext As String, SearchExact As Boolean, SearchArtNo As Boolean, SearchEAN As Boolean, SearchName As Boolean, SearchNameAddition As Boolean,
                   SearchPurchasingPrice As Boolean, SearchDiscount As Boolean, SearchListPrice As Boolean,
                   SearchSalesMargin As Boolean, SearchRetailPrice As Boolean, SearchNote As Boolean, SearchExpiring As Boolean,
                   SearchRetailPriceChanged As Boolean, RetailPriceChangedStartDate As Date, RetailPriceChangedEndDate As Date,
                   SearchPurchasingPriceChanged As Boolean, PurchasingPriceChangedStartDate As Date, PurchasingPriceChangedEndDate As Date)
        _Searchtext = Searchtext
        If SearchExact Then
            _Asterisk = ""
        Else
            _Asterisk = "*"
        End If
        _SearchArtNo = SearchArtNo
        _SearchEAN = SearchEAN
        _SearchName = SearchName
        _SearchNameAddition = SearchNameAddition
        _SearchPurchasingPrice = SearchPurchasingPrice
        _SearchDiscount = SearchDiscount
        _SearchListPrice = SearchListPrice
        _SearchSalesMargin = SearchSalesMargin
        _SearchRetailPrice = SearchRetailPrice
        _SearchNote = SearchNote
        _SearchExpiring = SearchExpiring
        _SearchRetailPriceChanged = SearchRetailPriceChanged
        _SearchPurchasingPriceChanged = SearchPurchasingPriceChanged
        If _SearchRetailPriceChanged Then
            _RetailPriceChangedStartDate = RetailPriceChangedStartDate.ToString("MM/dd/yyyy HH:mm:ss").Replace(".", "/")
            _RetailPriceChangedEndDate = RetailPriceChangedEndDate.ToString("MM/dd/yyyy HH:mm:ss").Replace(".", "/")
        End If
        If _SearchPurchasingPriceChanged Then
            _PurchasingPriceChangedStartDate = PurchasingPriceChangedStartDate.ToString("MM/dd/yyyy HH:mm:ss").Replace(".", "/")
            _PurchasingPriceChangedEndDate = PurchasingPriceChangedEndDate.ToString("MM/dd/yyyy HH:mm:ss").Replace(".", "/")
        End If
    End Sub
    Public Function BuildSearchstring() As String
        Dim Searchstring As String

        If _Searchtext.IsNotEmpty Then

            If _SearchArtNo Then Searchstring = AddParameterToSearchString(Searchstring, "ArtNr")
            If _SearchEAN Then Searchstring = AddParameterToSearchString(Searchstring, "EAN")
            If _SearchName Then Searchstring = AddParameterToSearchString(Searchstring, "Name1")
            If _SearchNameAddition Then Searchstring = AddParameterToSearchString(Searchstring, "Zusatz")
            If _SearchPurchasingPrice Then Searchstring = AddParameterToSearchString(Searchstring, "Convert(Einkaufspreis, System.String)")
            If _SearchDiscount Then Searchstring = AddParameterToSearchString(Searchstring, "Convert(Rabatt, System.String)")
            If _SearchListPrice Then Searchstring = AddParameterToSearchString(Searchstring, "Convert(Listenpreis, System.String)")
            If _SearchSalesMargin Then Searchstring = AddParameterToSearchString(Searchstring, "Convert(Marge, System.String)")
            If _SearchRetailPrice Then Searchstring = AddParameterToSearchString(Searchstring, "Convert(Verkaufspreis, System.String)")
            If _SearchNote Then Searchstring = AddParameterToSearchString(Searchstring, "Notiz")
        End If

        If _SearchExpiring Then
            If Searchstring = "" Then
                Searchstring = "auslauf = true"
            Else
                Searchstring = "(" & Searchstring & ") AND auslauf = true"
            End If
        End If

        If _SearchRetailPriceChanged Then
            If Searchstring = "" Then
                Searchstring = $"DatumletzteKalkulationVK >= #{_RetailPriceChangedStartDate}# AND DatumletzteKalkulationVK <= #{_RetailPriceChangedEndDate}#"
            Else
                Searchstring = "(" & Searchstring & $") AND DatumletzteKalkulationVK >= #{_RetailPriceChangedStartDate}# AND DatumletzteKalkulationVK <= #{_RetailPriceChangedEndDate}#"
            End If
        End If

        If _SearchPurchasingPriceChanged Then
            If Searchstring = "" Then
                Searchstring = $"DatumletzteKalkulationEK >= #{_PurchasingPriceChangedStartDate}# AND DatumletzteKalkulationEK <= #{_PurchasingPriceChangedEndDate}#"
            Else
                Searchstring = "(" & Searchstring & $") AND DatumletzteKalkulationEK >= #{_PurchasingPriceChangedStartDate}# AND DatumletzteKalkulationEK <= #{_PurchasingPriceChangedEndDate}#"
            End If
        End If

        Return Searchstring
    End Function
    Private Function AddParameterToSearchString(Searchstring As String, ParamterName As String) As String
        If Searchstring = "" Then
            Searchstring = $"{ParamterName} Like '{_Asterisk}{_Searchtext}{_Asterisk}'"
        Else
            Searchstring &= $"OR {ParamterName} LIKE '{_Asterisk}{_Searchtext}{_Asterisk}'"
        End If

        Return Searchstring
    End Function
End Class
