﻿Public Class HomeScreenDatenLaden
    Private _ArrSupplier As DtsDaten.LieferantRow()
    Public Sub New(ArrSupplier As DtsDaten.LieferantRow())
        _ArrSupplier = ArrSupplier
    End Sub
    Public Function GetOpenOrders() As (OpenOrders As List(Of String), TotalAmountofOpenOrders As Integer)
        Dim OpenOrders As New List(Of String)
        Dim MoreThanOneOpenOrders As Boolean
        Dim Suppliername As String
        Dim DateofReceive As String
        Dim DaysTillArrival As Integer
        Dim DeliverDurationText As String
        Dim TotalAmountOfOpenOrders = 0
        For Each Supplier In _ArrSupplier
            Dim Orders = Supplier.GetLieferungRows
            MoreThanOneOpenOrders = False
            For Each Order In Orders
                If Order.IsLieferdatumNull Then
                    If MoreThanOneOpenOrders Then
                        Suppliername = ""
                    Else
                        Suppliername = Supplier.Name
                    End If
                    MoreThanOneOpenOrders = True
                    TotalAmountOfOpenOrders += 1
                    If Supplier.IsLieferzeitDurchschnittNull Then
                        DateofReceive = "erste Lieferung"
                        DeliverDurationText = ""
                    Else
                        DateofReceive = Order.Bestelldatum.Date.AddDays(Math.Round(Supplier.LieferzeitDurchschnitt)).ToString("ddd dd.MM.yy")
                        If CDate(DateofReceive).DayOfWeek = 0 Then
                            DateofReceive = (CDate(DateofReceive).AddDays(1)).ToString("ddd dd.MM.yy")
                        End If
                        DaysTillArrival = CInt(Date.Parse(DateofReceive).Subtract(System.DateTime.Now.Date).TotalDays)
                        Select Case DaysTillArrival
                            Case > 1 : DeliverDurationText = "in " & DaysTillArrival & " Tagen"
                            Case = 1 : DeliverDurationText = "morgen"
                            Case = 0 : DeliverDurationText = "heute"
                            Case = -1 : DeliverDurationText = "gestern"
                            Case < -1 : DeliverDurationText = "vor " & DaysTillArrival * -1 & " Tagen"
                        End Select
                    End If
                    OpenOrders.Add($"{Suppliername}|{DeliverDurationText}|{DateofReceive}")
                End If
            Next
        Next
        Return (OpenOrders, TotalAmountOfOpenOrders)
    End Function
    Public Function GetOpenReclamations() As (OpenReclamations As List(Of String), TotalAmountofOpenReclamations As Integer)
        Dim TotalAmountofOpenReclamations = 0
        Dim OpenReclamations As New List(Of String)
        Dim MoreThanOneOpenReclamation As Boolean
        Dim Suppliername As String
        For Each Supplier In _ArrSupplier
            Dim ReclamationRows = Supplier.GetReklamationRows
            MoreThanOneOpenReclamation = False
            For Each ReclamationRow In ReclamationRows
                If ReclamationRow.IsDatumErledigtNull Then
                    If MoreThanOneOpenReclamation Then
                        Suppliername = ""
                    Else
                        Suppliername = Supplier.Name
                    End If
                    MoreThanOneOpenReclamation = True
                    TotalAmountofOpenReclamations += 1
                    OpenReclamations.Add($"{Suppliername}|vom {ReclamationRow.DatumReklamation.ToShortDateString}")
                End If
            Next
        Next
        Return (OpenReclamations, TotalAmountofOpenReclamations)
    End Function
    Public Function GetMissingInvoices() As (MissingInvoices As List(Of String), TotalAmountofMissingInvoices As Integer)
        Dim MissingInvoices As New List(Of String)
        Dim MoreThanOneMissingInvoice As Boolean
        Dim Suppliername As String
        Dim TotalAmountOfMissingInvoices = 0
        For Each Supplier In _ArrSupplier
            Dim Orders = Supplier.GetLieferungRows
            MoreThanOneMissingInvoice = False
            For Each Order In Orders
                If Not Order.IsLieferdatumNull AndAlso Order.IsRechnungserhaltNull Then
                    If MoreThanOneMissingInvoice Then
                        Suppliername = ""
                    Else
                        Suppliername = Supplier.Name
                    End If
                    MoreThanOneMissingInvoice = True
                    TotalAmountOfMissingInvoices += 1
                    MissingInvoices.Add($"{Suppliername}|vom {Order.Bestelldatum.ToShortDateString}")
                End If
            Next
        Next
        Return (MissingInvoices, TotalAmountOfMissingInvoices)
    End Function
    Public Function GetOpenCustomerOrders() As (OpenCustomerOrders As List(Of String), TotalAmountOfOpenCustomerOrders As Integer)
        Dim OpenCustomerOrders As New List(Of String)
        Dim MoreThanOneOpenCustomerOrder As Boolean
        Dim Suppliername As String
        Dim TotalAmountOfOpenCustomerOrders = 0
        For Each Supplier In _ArrSupplier
            Dim CustomerOrders = Supplier.GetKundenbestellungRows
            MoreThanOneOpenCustomerOrder = False
            For Each CustomerOrder In CustomerOrders
                If CustomerOrder.IsDatumAngerufenNull Then
                    If MoreThanOneOpenCustomerOrder Then
                        Suppliername = ""
                    Else
                        Suppliername = Supplier.Name
                    End If
                    MoreThanOneOpenCustomerOrder = True
                    TotalAmountOfOpenCustomerOrders += 1
                    OpenCustomerOrders.Add($"{Suppliername}|{CustomerOrder.ArtikelName}|vom {CustomerOrder.DatumKundenbestellt.ToShortDateString}")
                End If
            Next
        Next
        Return (OpenCustomerOrders, TotalAmountOfOpenCustomerOrders)
    End Function
End Class
