﻿Imports System.Runtime.CompilerServices
Module ModExtensions
    <Extension()> Public Function IsNotEmpty(Text As String) As Boolean
        Return Not String.IsNullOrEmpty(Text)
    End Function
    <Extension()> Public Function IsEmpty(Text As String) As Boolean
        Return String.IsNullOrEmpty(Text)
    End Function
    <Extension()> Public Function NotContains(Text As String, ContainsString As String) As Boolean
        Return Not Text.Contains(ContainsString)
    End Function
    <Extension()> Public Function At(Of T As DataRow)(bs As BindingSource) As T
        Return DirectCast(bs.At(bs.Position), T)
    End Function
    <Extension> Public Function RemoveCharacters(Text As String, CharactersToRemove As String) As String
        If String.IsNullOrEmpty(Text) Then Return Nothing
        Dim FinalText As New Text.StringBuilder
        For Each Character In Text
            If CharactersToRemove.Contains(Character) Then Continue For
            FinalText.Append(Character)
        Next
        Return FinalText.ToString
    End Function
    <Extension> Public Function CheckForIllegalChars(Text As String, IllegalChars As String) As (ContainesIllegalChar As Boolean, IllegalChar As String)
        If String.IsNullOrEmpty(Text) Then Return Nothing
        For Each Character In Text
            If IllegalChars.Contains(Character) Then Return (True, Character.ToString)
        Next
        Return (False, "")
    End Function
End Module
