﻿Imports System.IO

Module ModGlobalerCode
    Public Function ShowMessageBoxAndAskUserYesOrNo(Text As String) As Boolean
        Dim result As DialogResult
        Using Dialog As New dlgNachrichtJaNein
            With Dialog
                .SetDisplayText = Text
                .ShowDialog()
                result = Dialog.DialogResult
            End With
        End Using
        Select Case result
            Case = DialogResult.OK : Return True
            Case Else : Return False
        End Select
    End Function
    Public Sub ShowAutoClosingMessageBox(Text As String, Optional DisplayTime As Integer = 1)
        Using Messageform As New frmNachricht
            With Messageform
                .SetDisplayText = Text
                .SetAutoClose = True
                .SetDisplayTime = DisplayTime
                .ShowDialog()
            End With
        End Using
    End Sub
    Public Sub ShowMessageBox(Text As String)
        Using Messageform As New frmNachricht
            With Messageform
                .SetDisplayText = Text
                .SetAutoClose = False
                .ShowDialog()
            End With
        End Using
    End Sub
    Public Function GetDGVColumnWidthsAsSaveableString(DGV As DataGridView) As String
        Return String.Join(";", DGV.Columns.Cast(Of DataGridViewColumn).Take(DGV.Columns.Count - 1).Select(Function(x) x.Width.ToString))
    End Function
    Public Sub LoadDGVColumnwidths(DGV As DataGridView, Settings As String)
        If Settings.IsEmpty Then Return
        Dim widths() As String = Settings.Split(";"c)
        For i = 0 To DGV.Columns.Count - 2
            If widths(i) <> "" Then DGV.Columns(i).Width = Integer.Parse(widths(i))
        Next
    End Sub
    Public Function CheckForControlChars(TB As TextBox) As Boolean
        For Each item In TB.Text
            If Char.IsControl(item) Then Return True
        Next
        Return False
    End Function
    Public Sub RemoveLastCharFromSearchTextbox(TB As TextBox)
        If TB.Focused Then Return
        Dim SearchString = TB.Text
        If SearchString.Length > 0 Then TB.Text = SearchString.Substring(0, SearchString.Length - 1)
    End Sub
    Public Function IsSearchableKeyPressed(keydata As Keys) As (SearchableKeyPressed As Boolean, PressedKey As String)
        If keydata.IsBetween(Keys.A, Keys.Z) Then Return (True, keydata.ToString.ToLower)
        If keydata.IsBetween(Keys.D0, Keys.D9) Then Return (True, keydata.ToString.Substring(keydata.ToString.Length - 1))
        If keydata.IsBetween(Keys.NumPad0, Keys.NumPad9) Then Return (True, keydata.ToString.Substring(keydata.ToString.Length - 1))

        Select Case keydata
            Case Keys.Oem1 : Return (True, "ü")
            Case Keys.Oem7 : Return (True, "ä")
            Case Keys.Oemtilde : Return (True, "ö")
            Case Keys.Space : Return (True, " ")
            Case Keys.Subtract : Return (True, "-")
            Case Keys.OemMinus : Return (True, "-")
            Case Keys.Divide : Return (True, "/")
            Case Keys.Shift Or Keys.D7 : Return (True, "/")
            Case Keys.Shift Or Keys.D5 : Return (True, "%")
            Case Keys.Shift Or Keys.D2 : Return (True, """")
            Case Keys.Oemplus : Return (True, "+")
            Case Keys.Add : Return (True, "+")
        End Select

        Return (False, " ")
    End Function
    Public Function SetNewFilename(OldFileName As String, Extension As String, Optional DefaultText As String = "") As String
        Dim NewFilename As String
        Using NewFileNameForm As New dlgneuerDateiname
            With NewFileNameForm
                ._OldFileName = OldFileName
                ._Extension = Extension
                ._DefaultText = DefaultText
                If .ShowDialog() = DialogResult.OK Then
                    NewFilename = ._NewFileName
                End If
            End With
        End Using
        Return NewFilename
    End Function
    Public Function PossibleToShowFileInWebView(DroppedFileInfo As FileInfo) As Boolean
        Select Case DroppedFileInfo.Extension.ToLower
            Case = ".pdf", ".txt", ".jpg", ".png" : Return True
            Case Else : Return False
        End Select
    End Function
End Module
