﻿Module NumericTextBox
    Public Sub RegisterNumericTextboxInput(ParamArray numericTextBoxes As TextBox())
        For Each ntb In numericTextBoxes
            AddHandler ntb.KeyDown, AddressOf TextBox_numericKeyDown
            AddHandler ntb.Enter, AddressOf TextBox_Enter
        Next
    End Sub

    Private Sub TextBox_Enter(sender As Object, e As EventArgs)
        Dim tb = DirectCast(sender, TextBox)
        tb.SelectAll()
    End Sub
    Private Sub TextBox_numericKeyDown(sender As Object, e As KeyEventArgs)
        Dim tb = DirectCast(sender, TextBox)
        Select Case e.KeyCode
            Case Keys.D0 To Keys.D9, Keys.NumPad0 To Keys.NumPad9, Keys.Back
            Case Keys.Decimal
                If tb.Text.Contains(",") Then e.SuppressKeyPress = True
            Case Keys.Oemcomma
                If tb.Text.Contains(",") Then e.SuppressKeyPress = True
            Case Keys.Shift, Keys.Home, Keys.End, Keys.Delete, Keys.Left, Keys.Right
            Case Else : e.SuppressKeyPress = True
        End Select
    End Sub
End Module
