﻿Imports System.IO

Public Class UCArtikel
    Private _SaveDGVColumnWidths As Boolean
    Private _BSFilteredBySupplierIsActivated As Boolean = False

    Private Sub DGVArtikel_LostFocus(sender As Object, e As EventArgs) Handles DGVArtikel.LostFocus
        _SaveDGVColumnWidths = False
    End Sub
    Private Sub DGVArtikel_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles DGVArtikel.ColumnWidthChanged
        If _SaveDGVColumnWidths Then My.Settings.DGVArtikelSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVArtikel)
    End Sub
    Private Sub DGVArtikel_Click(sender As Object, e As EventArgs) Handles DGVArtikel.Click
        _SaveDGVColumnWidths = True
    End Sub
    Private Sub DGVArtikel_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVArtikel.CellDoubleClick
        EditItem()
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNArtikelNeu.Click, BTNArtikelKopieren.Click, BTNArtikelBearbeiten.Click,
            BTNArtikelLoeschen.Click, BTNSucheLoeschen.Click, BTNArtikelMitImportLaden.Click, BTNSucheinstellungen.Click,
            BTNAlleLieferantenZeigen.Click
        Select Case True
            Case sender Is BTNArtikelNeu : CreateNewItem()
            Case sender Is BTNArtikelKopieren : CopyItem()
            Case sender Is BTNArtikelBearbeiten : EditItem()
            Case sender Is BTNArtikelMitImportLaden : ShowItemFormWithImport()
            Case sender Is BTNArtikelLoeschen : DeleteItem()
            Case sender Is BTNSucheLoeschen : ClearItemSearch()
            Case sender Is BTNSucheinstellungen : ShowOrHideSearchOptions()
            Case sender Is BTNAlleLieferantenZeigen : ClearClearableComboBox()
        End Select
    End Sub
    Private Sub TBArtikelDurchsuchen_TextChanged(sender As Object, e As EventArgs) Handles TBArtikelDurchsuchen.TextChanged
        BuildSearchstringAndSearchItem()
    End Sub
    Private Sub CreateNewItem()
        Dim Dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim EditItemForm As New frmArtikelBearbeiten
        With EditItemForm
            .BSMain.DataSource = Dts
            .Show(Me)
        End With
    End Sub
    Private Sub CopyItem()
        Dim UsedBindingSource = GetUsedBindingsource()
        Dim SelectedItem = UsedBindingSource.At(Of DtsDaten.ArtikelRow)
        Dim Dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim EditItemForm As New frmArtikelBearbeiten
        With EditItemForm
            .BSMain.DataSource = Dts
            ._SelectedItem = SelectedItem
            ._CopyItem = True
            .Show(Me)
        End With
    End Sub
    Private Sub EditItem()
        Dim UsedBindingSource = GetUsedBindingsource()
        Dim SelectedItem = UsedBindingSource.At(Of DtsDaten.ArtikelRow)
        Dim Dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim EditItemForm As New frmArtikelBearbeiten
        With EditItemForm
            .BSMain.DataSource = Dts
            ._EditItem = True
            ._SelectedItem = SelectedItem
            .Show(Me)
        End With
    End Sub
    Private Sub ShowItemFormWithImport()
        Dim Dts = DirectCast(BSMain.DataSource, DtsDaten)
        Dim EditItemForm As New frmArtikelBearbeiten
        With EditItemForm
            .BSMain.DataSource = Dts
            ._ShowImport = True
            .Show(Me)
        End With
    End Sub
    Private Sub DeleteItem()
        Dim UsedBindingSource = GetUsedBindingsource()
        If UsedBindingSource.Current Is Nothing Then Return
        Dim SelectedItem = UsedBindingSource.At(Of DtsDaten.ArtikelRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Der Artikel {SelectedItem.Name1} wird gelöscht.
                Sind sie sicher?") Then BSArtikel.RemoveCurrent()
    End Sub
    Private Sub ShowOrHideSearchOptions()
        PNLSucheeinstellungen.Visible = Not PNLSucheeinstellungen.Visible
    End Sub
    Private Sub ClearClearableComboBox()
        CCBLieferant.Clear()
        _BSFilteredBySupplierIsActivated = Not CCBLieferant.IsEmpty
        SetBindingSource()
    End Sub
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
        Select Case keyData
            Case = Keys.Control Or Keys.N : CreateNewItem()
            Case = Keys.Control Or Keys.C : CopyItem()
            Case = Keys.Enter : EditItem()
            Case = Keys.Delete : If Not TBArtikelDurchsuchen.Focused Then DeleteItem()
            Case = Keys.Escape : ClearItemSearch()
            Case = Keys.Back : RemoveLastCharFromSearchTextbox(TBArtikelDurchsuchen)
            Case Else
                If IsWritableControlFocused() Then Return MyBase.ProcessCmdKey(msg, keyData)
                Dim PressedKeyData = IsSearchableKeyPressed(keyData)
                If PressedKeyData.SearchableKeyPressed Then
                    TBArtikelDurchsuchen.Text &= PressedKeyData.PressedKey
                Else
                    Return MyBase.ProcessCmdKey(msg, keyData)
                End If
        End Select
    End Function
    Private Function IsWritableControlFocused() As Boolean
        If TBArtikelDurchsuchen.Focused Then Return True
        If DTPVKend.Focused Then Return True
        If DTPVKStart.Focused Then Return True
        If DTPEKend.Focused Then Return True
        If DTPEKstart.Focused Then Return True
        Return False
    End Function
    Private Sub CBXSearch_CheckStateChanged(sender As Object, e As EventArgs) Handles CBXZusatz.CheckStateChanged, CBXVKGeaendert.CheckStateChanged, CBXVK.CheckStateChanged, CBXSpanne.CheckStateChanged, CBXRabatt.CheckStateChanged, CBXNotiz.CheckStateChanged, CBXName.CheckStateChanged, CBXLP.CheckStateChanged, CBXEKGeaendert.CheckStateChanged, CBXEK.CheckStateChanged, CBXEAN.CheckStateChanged, CBXAusgelaufen.CheckStateChanged, CBXArtNr.CheckStateChanged
        BuildSearchstringAndSearchItem()
    End Sub
    Private Sub DTPVK_ValueChanged(sender As Object, e As EventArgs) Handles DTPVKStart.ValueChanged, DTPVKend.ValueChanged
        If CBXVKGeaendert.Checked Then BuildSearchstringAndSearchItem()
    End Sub
    Private Sub DTPEK_ValueChanged(sender As Object, e As EventArgs) Handles DTPEKstart.ValueChanged, DTPEKend.ValueChanged
        If CBXEKGeaendert.Checked Then BuildSearchstringAndSearchItem()
    End Sub
    Private Sub BuildSearchstringAndSearchItem()
        Dim bs = GetUsedBindingsource()
        Dim SearchStringBuilder As New BildenDesArtikelSuchString(TBArtikelDurchsuchen.Text, RBGenau.Checked, CBXArtNr.Checked, CBXEAN.Checked,
            CBXName.Checked, CBXZusatz.Checked, CBXEK.Checked, CBXRabatt.Checked, CBXLP.Checked, CBXSpanne.Checked,
            CBXVK.Checked, CBXNotiz.Checked, CBXAusgelaufen.Checked, CBXVKGeaendert.Checked, DTPVKStart.Value,
            DTPVKend.Value, CBXEKGeaendert.Checked, DTPEKstart.Value, DTPEKend.Value)
        bs.Filter = SearchStringBuilder.BuildSearchstring
    End Sub
    Private Function GetUsedBindingsource() As BindingSource
        If _BSFilteredBySupplierIsActivated Then
            Return BSLieferantArtikel
        Else
            Return BSArtikel
        End If
    End Function
    Private Sub SetBindingSource()
        If _BSFilteredBySupplierIsActivated Then
            DGVArtikel.DataSource = BSLieferantArtikel
        Else
            DGVArtikel.DataSource = BSArtikel
        End If
    End Sub
    Private Sub ClearItemSearch()
        TBArtikelDurchsuchen.Text = ""
    End Sub
    Private Sub ToolStrip_Click(sender As Object, e As EventArgs) Handles TSSplitterHoeheSpeichern.Click, TSDateiLoeschen.Click,
            TSSchliessen.Click
        Select Case True
            Case sender Is TSSplitterHoeheSpeichern : SaveSplitterDistance()
            Case sender Is TSDateiLoeschen : DeleteShownFileAndClose()
            Case sender Is TSSchliessen : CloseFile()
        End Select
    End Sub
    Private Sub SaveSplitterDistance()
        My.Settings.SCArtikelSplitterDistance = Me.SCArtikel.SplitterDistance
        ShowAutoClosingMessageBox("Höhe gespeichert")
    End Sub
    Private Sub DeleteShownFileAndClose()
        If Me.WebView2.Source = Nothing Then Return
        Dim TheUri = Me.WebView2.Source.ToString
        Dim file = TheUri.Substring(8)
        Dim openedFile As New FileInfo(file)
        If openedFile.Exists Then
            openedFile.Delete()
            ShowAutoClosingMessageBox("Datei wurde gelöscht")
        End If
        Me.SCArtikel.Panel2Collapsed = True
    End Sub
    Private Sub CloseFile()
        Me.SCArtikel.Panel2Collapsed = True
    End Sub
    Private Sub CCBLieferant_SelectedValueChanged(sender As Object, e As EventArgs) Handles CCBLieferant.SelectedValueChanged
        _BSFilteredBySupplierIsActivated = Not CCBLieferant.IsEmpty
        SetBindingSource()
        BuildSearchstringAndSearchItem()
    End Sub
End Class
