﻿Public Class UCEinstellungen
    Private _SaveDGVColumnWidths As Boolean
    Private Sub DGV_LostFocus(sender As Object, e As EventArgs) Handles DGVEmailAdresse.LostFocus, DGVLieferant.LostFocus,
            DGVWarengruppe.LostFocus
        _SaveDGVColumnWidths = False
    End Sub
    Private Sub DGV_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles DGVEmailAdresse.ColumnWidthChanged,
             DGVLieferant.ColumnWidthChanged
        Select Case True
            Case sender Is DGVEmailAdresse : If _SaveDGVColumnWidths Then My.Settings.DGVEmailAdressenSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVEmailAdresse)
            Case sender Is DGVLieferant : If _SaveDGVColumnWidths Then My.Settings.DGVLieferantenSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVLieferant)
            Case sender Is DGVWarengruppe : If _SaveDGVColumnWidths Then My.Settings.DGVWarengruppeSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVWarengruppe)
        End Select
    End Sub
    Private Sub DGV_Click(sender As Object, e As EventArgs) Handles DGVEmailAdresse.Click, DGVLieferant.Click,
            DGVWarengruppe.Click
        _SaveDGVColumnWidths = True
    End Sub
    Private Sub Button_ClickEvent(sender As Object, e As EventArgs) Handles BTNNeueEmailAdresse.Click, BTNEmailAdresseAendern.Click, BTNEmailAdresseLoeschen.Click,
            BTNNeuerLieferant.Click, BTNLieferantAendern.Click, BTNLieferantLoeschen.Click, BTNNeueWarengruppe.Click, BTNWarengruppeAendern.Click,
            BTNWarengruppeLoeschen.Click, BTNNeueKategorie.Click, BTNKategorieAendern.Click, BTNKategorieLoeschen.Click,
            BTNFirmendatenAendern.Click, BTNFirmendatenKopieren.Click, BTNNeueKostenart.Click, BTNKostenartAendern.Click,
            BTNKostenartLoeschen.Click
        Select Case True
            Case sender Is BTNNeueEmailAdresse : CreateNewMailAddress()
            Case sender Is BTNEmailAdresseAendern : EditEmailAddress()
            Case sender Is BTNEmailAdresseLoeschen : DeleteEmailAddress()
            Case sender Is BTNNeuerLieferant : CreateNewSupplier()
            Case sender Is BTNLieferantAendern : EditSupplier()
            Case sender Is BTNLieferantLoeschen : DeleteSupplier()
            Case sender Is BTNNeueWarengruppe : CreateNewProductGroup()
            Case sender Is BTNWarengruppeAendern : EditProductGroup()
            Case sender Is BTNWarengruppeLoeschen : DeleteProductGroup()
            Case sender Is BTNNeueKategorie : CreateNewCategory()
            Case sender Is BTNKategorieAendern : EditCategory()
            Case sender Is BTNKategorieLoeschen : DeleteCategory()
            Case sender Is BTNFirmendatenAendern : ChangeCompanyInfos()
            Case sender Is BTNFirmendatenKopieren : CopyCompanyInfos()
            Case sender Is BTNNeueKostenart : CreateNewCost()
            Case sender Is BTNKostenartAendern : EditCost()
            Case sender Is BTNKostenartLoeschen : DeleteCost()
        End Select
    End Sub
    Private Sub CreateNewMailAddress()
        BSEmailAdresse.EditNew(Of dlgEmailAdresseBearbeiten)
    End Sub
    Private Sub EditEmailAddress()
        If BSEmailAdresse.Current Is Nothing Then Return
        BSEmailAdresse.EditCurrent(Of dlgEmailAdresseBearbeiten)
    End Sub
    Private Sub DeleteEmailAddress()
        If BSEmailAdresse.Current Is Nothing Then Return
        Dim EmailAddress = BSEmailAdresse.At(Of DtsDaten.EmailAdresseRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Die Emailadresse {EmailAddress.Adresse} wird gelöscht.
                Sind sie sicher?") Then BSEmailAdresse.RemoveCurrent()
    End Sub
    Private Sub CreateNewSupplier()
        BSLieferant.EditNew(Of dlgLieferantBearbeiten)
    End Sub
    Private Sub EditSupplier()
        If BSLieferant.Current Is Nothing Then Return
        BSLieferant.EditCurrent(Of dlgLieferantBearbeiten)
    End Sub
    Private Sub DeleteSupplier()
        If BSLieferant.Current Is Nothing Then Return
        Dim Supplier = BSLieferant.At(Of DtsDaten.LieferantRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Der Lieferant {Supplier.Name} wird gelöscht.
                Sind sie sicher?") Then BSLieferant.RemoveCurrent()
    End Sub
    Private Sub CreateNewProductGroup()
        BSWarengruppe.EditNew(Of dlgWarengruppeBearbeiten)
    End Sub
    Private Sub EditProductGroup()
        If BSWarengruppe.Current Is Nothing Then Return
        BSWarengruppe.EditCurrent(Of dlgWarengruppeBearbeiten)
    End Sub
    Private Sub DeleteProductGroup()
        If BSWarengruppe.Current Is Nothing Then Return
        Dim ProductGroup = BSWarengruppe.At(Of DtsDaten.WarengruppeRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Die Warengruppe {ProductGroup.Name} wird gelöscht.
                Sind sie sicher?") Then BSWarengruppe.RemoveCurrent()
    End Sub
    Private Sub CreateNewCategory()
        BSKategorie.EditNew(Of dlgKategorieBearbeiten)
    End Sub
    Private Sub EditCategory()
        If BSKategorie.Current Is Nothing Then Return
        BSKategorie.EditCurrent(Of dlgKategorieBearbeiten)
    End Sub
    Private Sub DeleteCategory()
        If BSKategorie.Current Is Nothing Then Return
        Dim CategoryName = BSKategorie.At(Of DtsDaten.KategorieRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Die Kategorie {CategoryName.Name} wird gelöscht.
                Sind sie sicher?") Then BSKategorie.RemoveCurrent()
    End Sub
    Private Sub CreateNewCost()
        BSKostenart.EditNew(Of dlgKostenArtBearbeiten)
    End Sub
    Private Sub EditCost()
        If BSKostenart.Current Is Nothing Then Return
        BSKostenart.EditCurrent(Of dlgKostenArtBearbeiten)
    End Sub
    Private Sub DeleteCost()
        If BSKostenart.Current Is Nothing Then Return
        Dim CostName = BSKostenart.At(Of DtsDaten.KostenartRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Die Kostenart {CostName.Name} wird gelöscht.
                Sind sie sicher?") Then BSKostenart.RemoveCurrent()
    End Sub
    Private Sub ChangeCompanyInfos()
        Dim CurrentSettings = BSEinstellung.At(Of DtsDaten.EinstellungRow)
        With CurrentSettings
            .FirmaName = TBName.Text
            .FirmaName2 = TBZusatz.Text
            .FirmaStrasse = TBStrasse.Text
            .FirmaHausNr = TBNr.Text
            .FirmaPLZ = TBPLZ.Text
            .FirmaOrt = TBOrt.Text
            .FirmaTel1 = TBTel1.Text
            .FirmaTel2 = TBTel2.Text
            .FirmaFax = TBFax.Text
            .FirmaMail1 = TBMail1.Text
            .FirmaMail2 = TBMail2.Text
            .FirmaUstID = TBUstId.Text
            .FirmaHRB = TBHRB.Text
            .FirmaSteuerNr = TBSteuernummer.Text
            .FirmaBIC1 = TBBIC1.Text
            .FirmaIBAN1 = TBIBAN1.Text
            .FirmaBank1 = TBBank1.Text
            .FirmaBIC2 = TBBIC2.Text
            .FirmaIBAN2 = TBIBAN2.Text
            .FirmaBank2 = TBBank2.Text
        End With
    End Sub
    Private Sub CopyCompanyInfos()
        Dim CurrentSettings = BSEinstellung.At(Of DtsDaten.EinstellungRow)
        Dim CopyString As String
        With CurrentSettings
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaName & " " & .FirmaName2, "")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaStrasse & " " & .FirmaHausNr, "")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaPLZ & " " & .FirmaOrt, "")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaTel1, "Telefon: ")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaTel2, "Telefon 2: ")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaFax, "Fax: ")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaMail1, "Mail: ")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaMail2, "Mail 2:")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaUstID, "UstID: ")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaSteuerNr, "Steuernummer: ")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaHRB, "HRB: ")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaBIC1 & " " & .FirmaIBAN1 & " " & .FirmaBank1, "Bankverbindung: ")
            CopyString = AddCompanyInfoToCopystring(CopyString, .FirmaBIC2 & " " & .FirmaIBAN2 & " " & .FirmaBank2, "Bankverbindung 2:")
        End With
        My.Computer.Clipboard.SetText(CopyString)
        ShowAutoClosingMessageBox("Firmendaten in die Zwischenablage kopiert.")
    End Sub
    Private Function AddCompanyInfoToCopystring(Copystring As String, CompanyInfo As String, Prefix As String) As String
        If CompanyInfo.IsNotEmpty Then
            If CompanyInfo.IsNotEmpty AndAlso CompanyInfo <> " " AndAlso CompanyInfo <> "  " Then
                Copystring &= $"{Prefix}{CompanyInfo} {Environment.NewLine}"
            End If
        End If
        Return Copystring
    End Function
End Class
