﻿Imports System.IO
Public Class UCKosten
    Private _CostPath As DirectoryInfo
    Private _CostFile As FileInfo
    Private Sub UCKosten_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        DGVDateiNamen.ClearSelection()
    End Sub

    Private Sub BSKostenart_CurrentChanged(sender As Object, e As EventArgs) Handles BSKostenart.CurrentChanged
        BuildCostPath()
        WriteFileNamesToDgv()
    End Sub
    Private Sub BuildCostPath()
        Dim SelectedCostType = BSKostenart.At(Of DtsDaten.KostenartRow)
        _CostPath = New DirectoryInfo($"{My.Application.Info.DirectoryPath}\Daten\Kosten\{SelectedCostType.Name}\")
    End Sub
    Private Sub WriteFileNamesToDgv()
        DGVDateiNamen.Rows().Clear()
        If Not _CostPath.Exists Then Return
        Dim files() As FileInfo = _CostPath.GetFiles("*.*")
        For Each file In files
            DGVDateiNamen.Rows().Add(file.Name)
        Next
        DGVDateiNamen.ClearSelection()
    End Sub
    Private Sub DGVDateiNamen_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVDateiNamen.CellClick
        _CostFile = New FileInfo(_CostPath.FullName & (DGVDateiNamen.Item(0, DGVDateiNamen.CurrentCell.RowIndex).Value.ToString))
        ShowFileInWebView2()
    End Sub
    Private Sub DGVDateiNamen_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVDateiNamen.CellDoubleClick
        OpenCostFile()
    End Sub
    Private Sub ShowFileInWebView2()
        If PossibleToShowFileInWebView(_CostFile) Then Me.WebView2.Source = New Uri(_CostFile.FullName)
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNOeffnen.Click, BTNverschieben.Click, BTNUmbenennen.Click, BTNLoeschen.Click
        Select Case True
            Case sender Is BTNOeffnen : OpenCostFile()
            Case sender Is BTNLoeschen : DeleteCostFile()
            Case sender Is BTNverschieben : MoveCostFile()
            Case sender Is BTNUmbenennen : RenameFile()
        End Select
    End Sub
    Private Sub OpenCostFile()
        If _CostFile.Exists Then
            Process.Start(_CostFile.FullName)
        Else
            ShowAutoClosingMessageBox("Die Datei wurde nicht gefunden")
        End If
    End Sub
    Private Sub DeleteCostFile()
        If _CostFile Is Nothing Then Return
        If ShowMessageBoxAndAskUserYesOrNo($"Möchten Sie die Datei {_CostFile.Name} wirklich löschen?") Then
            If _CostFile.Exists Then _CostFile.Delete()
        End If
        WriteFileNamesToDgv()
        _CostFile = Nothing
        ShowAutoClosingMessageBox("Datei wurde gelöscht")
    End Sub
    Private Sub MoveCostFile()
        If _CostFile Is Nothing Then Return
        If Not _CostFile.Exists Then Return
        Dim File(0) As String
        File(0) = _CostFile.FullName
        frmHaupt.processDroppedFiles(File, True)
        WriteFileNamesToDgv()
        _CostFile = Nothing
    End Sub
    Private Sub RenameFile()
        If Not _CostPath.Exists Then Return
        If _CostFile Is Nothing Then Return
        If Not _CostFile.Exists Then Return

        Dim extension = _CostFile.Extension
        Dim newname As String = Microsoft.VisualBasic.InputBox("Bitte den neuen Dateinamen ohne Endung eingeben", "Datei umbenennen", Path.GetFileNameWithoutExtension(_CostFile.Name))
        If newname.IsEmpty Then
            Return
        Else
            newname &= extension
        End If

        If Not File.Exists(_CostPath.FullName & newname) Then
            Microsoft.VisualBasic.Rename(_CostPath.FullName & _CostFile.Name, _CostPath.FullName & newname)
            WriteFileNamesToDgv()
            _CostFile = New FileInfo(_CostPath.FullName & newname)
        Else
            ShowAutoClosingMessageBox($"Umbennen nicht möglich {Environment.NewLine} Dieser Dateiname existiert bereits.")
        End If
    End Sub
End Class
