﻿Public Class UCLoginDaten
    Private _SaveDGVColumnWidths As Boolean
    Private Sub DGVLoginDaten_LostFocus(sender As Object, e As EventArgs) Handles DGVLoginDaten.LostFocus
        _SaveDGVColumnWidths = False
    End Sub
    Private Sub DGVLoginDaten_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles DGVLoginDaten.ColumnWidthChanged
        If _SaveDGVColumnWidths Then My.Settings.DGVPasswortSpaltenBreite = GetDGVColumnWidthsAsSaveableString(DGVLoginDaten)
    End Sub
    Private Sub DGVLoginDaten_Click(sender As Object, e As EventArgs) Handles DGVLoginDaten.Click
        _SaveDGVColumnWidths = True
    End Sub
    Private Sub DGVLoginDaten_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVLoginDaten.CellDoubleClick
        EditLogin()
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNLoginNeu.Click, BTNLoginBearbeiten.Click,
        BTNLoginLoeschen.Click, BTNLoginKopieren.Click, BTNSucheLoeschen.Click, BTNURLOeffnen.Click
        Select Case True
            Case sender Is BTNLoginNeu : CreateNewLogin()
            Case sender Is BTNLoginBearbeiten : EditLogin()
            Case sender Is BTNLoginLoeschen : DeleteLogin()
            Case sender Is BTNLoginKopieren : CopyLoginToClipboard()
            Case sender Is BTNURLOeffnen : OpenURL()
            Case sender Is BTNSucheLoeschen : ClearLoginSearch()
        End Select
    End Sub
    Private Sub TBLoginDurchsuchen_TextChanged(sender As Object, e As EventArgs) Handles TBLoginDurchsuchen.TextChanged
        SearchLogins()
    End Sub
    Private Sub SearchLogins()
        Dim Searchtext As String = TBLoginDurchsuchen.Text
        BSLoginDaten.Filter = "Name Like '%" & Searchtext & "%' OR URL like '%" & Searchtext & "%'"
    End Sub
    Private Sub CreateNewLogin()
        BSLoginDaten.EditNew(Of dlgLoginDatenBearbeiten)
    End Sub
    Private Sub EditLogin()
        If BSLoginDaten.Current Is Nothing Then Return
        BSLoginDaten.EditCurrent(Of dlgLoginDatenBearbeiten)
    End Sub
    Private Sub DeleteLogin()
        If BSLoginDaten.Current Is Nothing Then Return
        Dim SelectedLogin = BSLoginDaten.At(Of DtsDaten.LoginDatenRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Der Login von {SelectedLogin.Name} wird gelöscht.
                Sind sie sicher?") Then BSLoginDaten.RemoveCurrent()
    End Sub
    Private Sub CopyLoginToClipboard()
        Dim ResultText As String
        If BSLoginDaten.Current Is Nothing Then Exit Sub
        Dim SelectedLogin = BSLoginDaten.At(Of DtsDaten.LoginDatenRow)
        If SelectedLogin.Passwort.IsNotEmpty Then
            My.Computer.Clipboard.SetText(SelectedLogin.Passwort)
            ResultText = "Passwort in die Zwischenablage kopiert."
        Else
            ResultText = "kein Passwort gespeichert"
        End If
        ShowAutoClosingMessageBox(ResultText)
    End Sub
    Private Sub OpenURL()
        If BSLoginDaten.Current Is Nothing Then Exit Sub
        Dim SelectedLogin = BSLoginDaten.At(Of DtsDaten.LoginDatenRow)
        If SelectedLogin.URL.IsNotEmpty Then
            Process.Start(SelectedLogin.URL)
        Else
            ShowAutoClosingMessageBox("keine URL gespeichert")
        End If
    End Sub
    Private Sub ClearLoginSearch()
        TBLoginDurchsuchen.Text = ""
        BSLoginDaten.RemoveFilter()
    End Sub
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
        Select Case keyData
            Case = Keys.Control Or Keys.N : CreateNewLogin()
            Case = Keys.Enter : EditLogin()
            Case = Keys.Delete : If Not TBLoginDurchsuchen.Focused Then DeleteLogin()
            Case = Keys.Escape : ClearLoginSearch()
            Case = Keys.Back : RemoveLastCharFromSearchTextbox(TBLoginDurchsuchen)
            Case Else
                If TBLoginDurchsuchen.Focused Then Return MyBase.ProcessCmdKey(msg, keyData)
                Dim PressedKeyData = IsSearchableKeyPressed(keyData)
                If PressedKeyData.SearchableKeyPressed Then
                    TBLoginDurchsuchen.Text &= PressedKeyData.PressedKey
                Else
                    Return MyBase.ProcessCmdKey(msg, keyData)
                End If
        End Select
    End Function
End Class
