﻿Public Class UCSonderpreise
    Private _SaveDGVColumnWidths As Boolean
    Private Sub DGVSonderpreis_LostFocus(sender As Object, e As EventArgs) Handles DGVSonderpreis.LostFocus
        _SaveDGVColumnWidths = False
    End Sub
    Private Sub DGVSonderpreis_ColumnWidthChanged(sender As Object, e As DataGridViewColumnEventArgs) Handles DGVSonderpreis.ColumnWidthChanged
        If _SaveDGVColumnWidths Then My.Settings.DGVSonderpreiseBreite = GetDGVColumnWidthsAsSaveableString(DGVSonderpreis)
    End Sub
    Private Sub DGVSonderpreis_Click(sender As Object, e As EventArgs) Handles DGVSonderpreis.Click
        _SaveDGVColumnWidths = True
    End Sub
    Private Sub DGVSonderpreis_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVSonderpreis.CellDoubleClick
        EditSpecialPrice()
    End Sub
    Private Sub BTN_Click(sender As Object, e As EventArgs) Handles BTNSonderpreisNeu.Click, BTNSonderpreisBearbeiten.Click, BTNSonderpreisKopieren.Click,
                                                                    BTNSonderpreisLoeschen.Click, BTNSucheLoeschen.Click
        Select Case True
            Case sender Is BTNSonderpreisNeu : CreateNewSpecialPrice()
            Case sender Is BTNSonderpreisBearbeiten : EditSpecialPrice()
            Case sender Is BTNSonderpreisKopieren : CopySpecialPrice()
            Case sender Is BTNSonderpreisLoeschen : DeleteSpecialPrice()
            Case sender Is BTNSucheLoeschen : ClearSpecialPriceSearch()
        End Select
    End Sub
    Private Sub TBSonderpreisDurchsuchen_TextChanged(sender As Object, e As EventArgs) Handles TBSonderpreisDurchsuchen.TextChanged
        SearchSpecialPrices()
    End Sub
    Private Sub SearchSpecialPrices()
        Dim Searchtext As String = TBSonderpreisDurchsuchen.Text
        BSSonderpreis.Filter = "Kundenname Like '%" & Searchtext & "%' OR Artikel like '%" & Searchtext & "%' OR Notiz like '%" & Searchtext & "%'"
    End Sub
    Private Sub CreateNewSpecialPrice()
        BSSonderpreis.EditNew(Of dlgSonderpreisBearbeiten)
    End Sub
    Private Sub EditSpecialPrice()
        If BSSonderpreis.Current Is Nothing Then Return
        BSSonderpreis.EditCurrent(Of dlgSonderpreisBearbeiten)
    End Sub
    Private Sub CopySpecialPrice()
        Dim Dts = DirectCast(BSMain.DataSource, DtsDaten)
        If BSSonderpreis.Current Is Nothing Then Return
        Dim SelectedSpecialPrice = BSSonderpreis.At(Of DtsDaten.SonderpreisRow)
        Dim tpls As New List(Of Tuple(Of DataColumn, Object))
        With Dts.Sonderpreis
            tpls.Add(Tuple.Create(Of DataColumn, Object)(.KundennameColumn, SelectedSpecialPrice.Kundenname))
            BSSonderpreis.EditNew(Of dlgSonderpreisBearbeiten)(tpls)
        End With
    End Sub
    Private Sub DeleteSpecialPrice()
        If BSSonderpreis.Current Is Nothing Then Return
        Dim SelectedSpecialPrice = BSSonderpreis.At(Of DtsDaten.SonderpreisRow)
        If ShowMessageBoxAndAskUserYesOrNo($"Der Sonderpreis von {SelectedSpecialPrice.Kundenname} für {SelectedSpecialPrice.Artikel} wird gelöscht.
                Sind sie sicher?") Then BSSonderpreis.RemoveCurrent()
    End Sub
    Private Sub ClearSpecialPriceSearch()
        TBSonderpreisDurchsuchen.Text = ""
        BSSonderpreis.RemoveFilter()
    End Sub
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean
        Select Case keyData
            Case = Keys.Control Or Keys.N : CreateNewSpecialPrice()
            Case = Keys.Control Or Keys.C : CopySpecialPrice()
            Case = Keys.Enter : EditSpecialPrice()
            Case = Keys.Delete : If Not TBSonderpreisDurchsuchen.Focused Then DeleteSpecialPrice()
            Case = Keys.Escape : ClearSpecialPriceSearch()
            Case = Keys.Back : RemoveLastCharFromSearchTextbox(TBSonderpreisDurchsuchen)
            Case Else
                If TBSonderpreisDurchsuchen.Focused Then Return MyBase.ProcessCmdKey(msg, keyData)
                Dim PressedKeyData = IsSearchableKeyPressed(keyData)
                If PressedKeyData.SearchableKeyPressed Then
                    TBSonderpreisDurchsuchen.Text &= PressedKeyData.PressedKey
                Else
                    Return MyBase.ProcessCmdKey(msg, keyData)
                End If
        End Select
    End Function
End Class
