﻿Imports System.IO
Imports OfficeOpenXml.FormulaParsing.Excel.Functions.RefAndLookup

Public Class frmHaupt
    Private _xmlFile As String = "Daten\Settings.xml"
    Private Exportclass As Export
    Private Sub frmHaupt_Closed(sender As Object, e As EventArgs) Handles Me.Closed
        SaveDts()
    End Sub
    Private Sub SaveDts()
        DtsDaten.WriteXml(_xmlFile)
    End Sub
    Private Sub frmHaupt_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        CheckForSettingsUpdate()
        AddHandlersForEmailSending()
        AddHandlersForOrders()
        AddHandlersForReclamation()
        HideTabControlHeaders()
        SetAllDGVBindingSources()
        CreateDataFolder()
        LoadDts()
        CheckIfSettingsRowExistsAndCreate()
        ClearClearableComboBoxes()
        SetWidthOfArticleSearchPanel()
        HideSCArtikelPanelOnUCArtikel()
        DrawHomeScreen()
        WriteDateToMenuStrip()
        LoadStatisticRecords()
        LoadDGVColumnwidths(UcAdressen.DGVAdresse, My.Settings.DGVAdressenSpaltenBreite)
        LoadDGVColumnwidths(UcEinstellungen.DGVEmailAdresse, My.Settings.DGVEmailAdressenSpaltenBreite)
        LoadDGVColumnwidths(UcEinstellungen.DGVLieferant, My.Settings.DGVLieferantenSpaltenBreite)
        LoadDGVColumnwidths(UcEinstellungen.DGVWarengruppe, My.Settings.DGVWarengruppeSpaltenBreite)
        LoadDGVColumnwidths(UcKundenbestellung.DGVKundenbestellung, My.Settings.DGVKundenbestellungenBreite)
        LoadDGVColumnwidths(UcSonderpreise.DGVSonderpreis, My.Settings.DGVSonderpreiseBreite)
        LoadDGVColumnwidths(UcLieferungen.DGVLieferungen, My.Settings.DGVLieferungenSpaltenBreite)
        LoadDGVColumnwidths(UcArtikel.DGVArtikel, My.Settings.DGVArtikelSpaltenBreite)
        LoadDGVColumnwidths(UcLoginDaten.DGVLoginDaten, My.Settings.DGVPasswortSpaltenBreite)
        LoadDGVColumnwidths(UcReklamation.DGVReklamation, My.Settings.DGVReklamationSpaltenBreite)

        PrepareStuffForVaporized()
    End Sub
    Private Sub PrepareStuffForVaporized()
        If DtsDaten.Artikel.Rows.Count > 0 Then Return

        Dim NewLieferantRow As DtsDaten.LieferantRow
        NewLieferantRow = DtsDaten.Lieferant.NewLieferantRow
        NewLieferantRow.Name = "LF1"
        DtsDaten.Lieferant.Rows.Add(NewLieferantRow)

        Dim NewKategorieRow As DtsDaten.KategorieRow
        NewKategorieRow = DtsDaten.Kategorie.NewKategorieRow
        NewKategorieRow.Name = "Kat1"
        DtsDaten.Kategorie.Rows.Add(NewKategorieRow)

        Dim NewProductGroupRow As DtsDaten.WarengruppeRow
        NewProductGroupRow = DtsDaten.Warengruppe.NewWarengruppeRow
        NewProductGroupRow.Name = "WG1"
        NewProductGroupRow.Nummer = 1
        DtsDaten.Warengruppe.Rows.Add(NewProductGroupRow)

        For i = 1 To 12048
            Dim NewArticleRow As DtsDaten.ArtikelRow
            NewArticleRow = DtsDaten.Artikel.NewArtikelRow
            With NewArticleRow
                .ArtNr = i.ToString
                .Name1 = "Name " & i
                .Zusatz = "Zusatz " & i
                .Ve = 1
                .Listenpreis = CDec(1.2)
                .Rabatt = 10
                .Einkaufspreis = CDec(1.08)
                .Marge = 100
                .Verkaufspreis = CDec(2.57)
                .Steuer = 19
                .auslauf = False
                .LieferantID = -1
                .KategorieID = -1
                .WarengruppeID = -1
            End With
            DtsDaten.Artikel.Rows.Add(NewArticleRow)
        Next
    End Sub
    Private Sub frmHaupt_Resize(sender As Object, e As EventArgs) Handles MyBase.Resize
        DrawHomeScreen()
    End Sub
    Private Sub CheckForSettingsUpdate()
        If Not My.Settings.Updated Then
            My.Settings.Upgrade()
            My.Settings.Updated = True
        End If
    End Sub
    Private Sub AddHandlersForEmailSending()
        AddHandler MailSendenKlasse.FinishedSendingMail, AddressOf HideStatusStripForMailSending
        AddHandler MailSendenKlasse.StartSendingMail, AddressOf ShowStatusStripForMailSending
    End Sub
    Private Sub ShowStatusStripForMailSending(Text As String)
        StatusStripProgressBar.Style = ProgressBarStyle.Marquee
        StatusStripTextLabel.Text = Text
        StatusStrip1.Visible = True
    End Sub
    Private Sub HideStatusStripForMailSending()
        StatusStripTextLabel.Text = ""
        StatusStrip1.Visible = False
    End Sub
    Private Sub AddHandlersForOrders()
        AddHandler UcLieferungen.OpenCustomerOrderFound, AddressOf ShowCustomerOrderPage
    End Sub
    Private Sub AddHandlersForReclamation()
        AddHandler UcLieferungen.OpenReclamationFound, AddressOf ShowReclamationPage
    End Sub
    Private Sub HideTabControlHeaders()
        With TCHaupt
            .SuspendLayout()
            .SizeMode = TabSizeMode.Fixed
            .ItemSize = New Size(0, 1)
            .Appearance = TabAppearance.Buttons
            .ResumeLayout()
        End With
    End Sub
    Private Sub SetAllDGVBindingSources()
        UcAdressen.BSMain.DataSource = DtsDaten
        UcEinstellungen.BSMain.DataSource = DtsDaten
        UcKundenbestellung.BSMain.DataSource = DtsDaten
        UcSonderpreise.BSMain.DataSource = DtsDaten
        UcLieferungen.BSMain.DataSource = DtsDaten
        UcArtikel.BSMain.DataSource = DtsDaten
        UcLoginDaten.BSMain.DataSource = DtsDaten
        UcReklamation.BSMain.DataSource = DtsDaten
        UcKosten.BSMain.DataSource = DtsDaten
    End Sub
    Private Sub CreateDataFolder()
        Directory.CreateDirectory(My.Application.Info.DirectoryPath & "\Daten")
    End Sub
    Private Sub LoadDts()
        If File.Exists(_xmlFile) Then DtsDaten.ReadXml(_xmlFile)
    End Sub
    Private Sub CheckIfSettingsRowExistsAndCreate()
        If DtsDaten.Einstellung.Rows.Count = 0 Then
            DtsDaten.Einstellung.AddEinstellungRow("", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", 441234500000)
        End If
    End Sub
    Private Sub ClearClearableComboBoxes()
        UcKundenbestellung.CCBLieferant.Clear()
        UcArtikel.CCBLieferant.Clear()
        UcReklamation.CCBLieferant.Clear()
    End Sub
    Private Sub SetWidthOfArticleSearchPanel()
        UcArtikel.PNLSucheeinstellungen.Width = CInt(UcArtikel.DGVArtikel.Width / 4)
        Dim xPoint = UcArtikel.DGVArtikel.Width - UcArtikel.PNLSucheeinstellungen.Width
        UcArtikel.PNLSucheeinstellungen.Location = New Point(xPoint, 1)
    End Sub
    Private Sub HideSCArtikelPanelOnUCArtikel()
        UcArtikel.SCArtikel.Panel2Collapsed = True
    End Sub
    Private Sub WriteDateToMenuStrip()
        TSDatum.Text = DateTime.Now.ToString("ddd dd.MM.yyyy")
        TSKW.Text = $"KW: {Globalization.CultureInfo.CurrentCulture.Calendar.GetWeekOfYear(DateTime.Now, System.Globalization.CalendarWeekRule.FirstFourDayWeek, DayOfWeek.Monday)}"
    End Sub
    Private Sub LoadStatisticRecords()
        If DtsDaten.Tageseinnahme.Rows.Count > 0 Then
            DtsDaten.LoadDailyRecords()
            DtsDaten.CalculateMonthlyRecords()
        End If
    End Sub
    Private Sub MSEintrag_Click(sender As Object, e As EventArgs) Handles MSStart.Click, MSAdressen.Click, MSEinstellungen.Click,
            MSKundenbestellungen.Click, MSSonderpreise.Click, MSLieferung.Click, MSArtikel.Click,
            MSPasswoerter.Click, MSReklamationen.Click, MSDateiAuswahl.Click, MSPreislistenAnzeigen.Click,
            MSStocklistenAnzeigen.Click, MSAngeboteAnzeigen.Click, MSBestellungenAnzeigen.Click,
            MSRechnungenAnzeigen.Click, MSKosten.Click, MSStatistikeintrag.Click, MSStatistikAuswertung.Click,
            MSStatistikRekorde.Click, MSDGVexportieren.Click, MSKassenexport.Click
        Select Case True
            Case sender Is MSStart : ShowStartPage()
            Case sender Is MSAdressen : ShowAddressPage()
            Case sender Is MSEinstellungen : ShowSettingsPage()
            Case sender Is MSKundenbestellungen : ShowCustomerOrderPage(Nothing)
            Case sender Is MSSonderpreise : ShowSpecialPricesPage()
            Case sender Is MSLieferung : SelectSupplierAndShowDeliveryPage()
            Case sender Is MSArtikel : ShowArticlePage()
            Case sender Is MSPasswoerter : ShowPasswordPage()
            Case sender Is MSReklamationen : ShowReclamationPage(Nothing)
            Case sender Is MSKosten : ShowCostPage()
            Case sender Is MSDateiAuswahl : LoadFilesToProccess()
            Case sender Is MSPreislistenAnzeigen : LoadList(My.Application.Info.DirectoryPath & "\Daten\Preislisten\", "Preislisten")
            Case sender Is MSStocklistenAnzeigen : LoadList(My.Application.Info.DirectoryPath & "\Daten\Stocklisten\", "Stocklisten")
            Case sender Is MSAngeboteAnzeigen : LoadList(My.Application.Info.DirectoryPath & "\Daten\Angebote\", "Angebote")
            Case sender Is MSBestellungenAnzeigen : LoadList(My.Application.Info.DirectoryPath & "\Daten\Bestellungen\", "Bestellungen")
            Case sender Is MSRechnungenAnzeigen : LoadList(My.Application.Info.DirectoryPath & "\Daten\Rechnungen\", "Rechnungen")
            Case sender Is MSDGVexportieren : ExportDGV()
            Case sender Is MSKassenexport : ExportCashRegisterData()
            Case sender Is MSStatistikeintrag : ShowDailyIncomeForm()
            Case sender Is MSStatistikAuswertung : ShowEvaluationForm()
            Case sender Is MSStatistikRekorde : ShowStatisticRecords()
        End Select
    End Sub
    Private Sub LoadList(Path As String, ListType As String)
        Dim Suppliername = SelectSupplierByName()
        Path &= $"{Suppliername}\"
        Dim TargetPath = New DirectoryInfo(Path)
        If Not TargetPath.Exists Then
            ShowAutoClosingMessageBox($"Ordner für {ListType} existiert nicht.")
            Return
        End If
        Using FileChoose As New frmDateiAuswahl
            With FileChoose
                ._Path = Path
                .ShowDialog()
            End With
        End Using
    End Sub
    Private Sub ExportDGV()
        Dim DGVToExport As DataGridView
        Select Case True
            Case TCHaupt.SelectedTab Is TPAdressen : DGVToExport = UcAdressen.DGVAdresse
            Case TCHaupt.SelectedTab Is TPArtikel : DGVToExport = UcArtikel.DGVArtikel
            Case TCHaupt.SelectedTab Is TPKundenbestellungen : DGVToExport = UcKundenbestellung.DGVKundenbestellung
            Case TCHaupt.SelectedTab Is TPLieferungen : DGVToExport = UcLieferungen.DGVLieferungen
            Case TCHaupt.SelectedTab Is TPReklamation : DGVToExport = UcReklamation.DGVReklamation
            Case TCHaupt.SelectedTab Is TPSonderpreis : DGVToExport = UcSonderpreise.DGVSonderpreis
            Case TCHaupt.SelectedTab Is TPLoginDaten : DGVToExport = UcLoginDaten.DGVLoginDaten
            Case Else
                ShowAutoClosingMessageBox("Hier gibt es nichts zu exportieren.")
                Return
        End Select

        Exportclass = New Export(DGVToExport)
        AddHandler Exportclass.ExportStartet, AddressOf ShowStatusStripForExport
        AddHandler Exportclass.ExportFinished, AddressOf HideStatusStripForExport
        AddHandler Exportclass.ProgressReporter.ProgressChanged, AddressOf ShowExportProgress
        Exportclass.CollectUserDataForDGVExport()
    End Sub
    Private Sub ShowStatusStripForExport(Text As String)
        StatusStripProgressBar.Style = ProgressBarStyle.Continuous
        StatusStripBTNabbrechen.Visible = True
        StatusStripTextLabel.Text = Text
        StatusStrip1.Visible = True
    End Sub
    Private Sub HideStatusStripForExport()
        StatusStripBTNabbrechen.Visible = False
        StatusStripTextLabel.Text = ""
        StatusStrip1.Visible = False
    End Sub
    Private Sub ShowExportProgress(sender As Object, e As Integer)
        StatusStripProgressBar.Value = e
    End Sub
    Private Sub StatusStripBTNabbrechen_Click(sender As Object, e As EventArgs) Handles StatusStripBTNabbrechen.Click
        Exportclass._Cancel = True
    End Sub
    Private Sub ExportCashRegisterData()
        Exportclass = New Export(UcArtikel.DGVArtikel)
        AddHandler Exportclass.ExportStartet, AddressOf ShowStatusStripForExport
        AddHandler Exportclass.ExportFinished, AddressOf HideStatusStripForExport
        AddHandler Exportclass.ProgressReporter.ProgressChanged, AddressOf ShowExportProgress
        Exportclass.ExportCashRegisterData()
    End Sub
    Private Sub ShowDailyIncomeForm()
        Dim NewIncome As New frmneueEinnahme
        With NewIncome
            .BSMain.DataSource = Me.DtsDaten
            .Show()
        End With
    End Sub
    Private Sub ShowEvaluationForm()
        Dim Evaluation As New frmStatistikAuswertung
        With Evaluation
            .BSMain.DataSource = Me.DtsDaten
            .Show()
        End With
    End Sub
    Private Sub ShowStatisticRecords()
        Dim StatisticRecords As New frmStatistikRekorde
        With StatisticRecords
            .BSMain.DataSource = Me.DtsDaten
            .Show()
        End With
    End Sub
    Private Sub ShowStartPage()
        DrawHomeScreen()
        TCHaupt.SelectedTab = TPStart
    End Sub
    Private Sub ShowAddressPage()
        TCHaupt.SelectedTab = TPAdressen
    End Sub
    Private Sub ShowSettingsPage()
        TCHaupt.SelectedTab = TPEinstellungen
    End Sub
    Private Sub ShowCustomerOrderPage(BSCurrent As Object)
        If Not BSCurrent Is Nothing Then
            UcKundenbestellung.CCBLieferant.UndoClear()
            UcKundenbestellung.SetSupplierToShow(BSCurrent)
        End If
        TCHaupt.SelectedTab = TPKundenbestellungen
    End Sub
    Private Sub ShowSpecialPricesPage()
        TCHaupt.SelectedTab = TPSonderpreis
    End Sub
    Private Sub SelectSupplierAndShowDeliveryPage()
        Dim SelectedSupplierPosition As Integer = SelectSupplierByPosition()
        If SelectedSupplierPosition = -1 Then Return
        UcLieferungen.BSLieferant.Position = SelectedSupplierPosition
        UcLieferungen.BTNAuswaehlen.Visible = False
        TCHaupt.SelectedTab = TPLieferungen
    End Sub
    Public Function SelectSupplierByPosition() As Integer
        Dim Position As Integer
        Using SupplierSelect As New dlgLieferantenAuswahl
            SupplierSelect.BSMain.DataSource = DtsDaten
            SupplierSelect.Location = My.Settings.dlgLieferantenAuswahlPosition
            If SupplierSelect.ShowDialog = DialogResult.OK Then
                Position = SupplierSelect.SupplierPosition
            Else
                Position = -1
            End If
            Return Position
        End Using
    End Function
    Private Sub ShowArticlePage()
        TCHaupt.SelectedTab = TPArtikel
    End Sub
    Private Sub ShowPasswordPage()
        TCHaupt.SelectedTab = TPLoginDaten
    End Sub
    Private Sub ShowReclamationPage(BSCurrent As Object)
        If Not BSCurrent Is Nothing Then
            UcReklamation.CCBLieferant.UndoClear()
            UcReklamation.SetSupplierToShow(BSCurrent)
        End If
        TCHaupt.SelectedTab = TPReklamation
    End Sub
    Private Sub ShowCostPage()
        TCHaupt.SelectedTab = TPKosten
    End Sub
    Private Sub LoadFilesToProccess()
        Dim openedfiles() As String
        Using OFD As New OpenFileDialog
            With OFD
                .InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory)
                .Multiselect = True
                If .ShowDialog <> DialogResult.OK Then Return
                ReDim openedfiles(.FileNames.Length - 1)

                For i = 0 To .FileNames.Length - 1
                    openedfiles(i) = .FileNames(i)
                Next
            End With
        End Using
        processDroppedFiles(openedfiles, False)
    End Sub
    Public Function SelectSupplierByName() As String
        Dim Name As String
        Using SupplierSelect As New dlgLieferantenAuswahl
            SupplierSelect.BSMain.DataSource = DtsDaten
            SupplierSelect.Location = My.Settings.dlgLieferantenAuswahlPosition
            If SupplierSelect.ShowDialog = DialogResult.OK Then
                Name = SupplierSelect.SupplierName
            End If
            Return Name
        End Using
    End Function
    Private Function SelectSupplierByID() As Integer
        Dim ID As Integer
        Using SupplierSelect As New dlgLieferantenAuswahl
            SupplierSelect.BSMain.DataSource = DtsDaten
            SupplierSelect.Location = My.Settings.dlgLieferantenAuswahlPosition
            If SupplierSelect.ShowDialog = DialogResult.OK Then
                ID = SupplierSelect.SupplierID
            Else
                ID = 1
            End If
            Return ID
        End Using
    End Function
End Class