﻿Partial Class frmHaupt
    Private Sub DrawHomeScreen()
        ClearHomeScreen()
        Dim GetDataForHomeScreen As New HomeScreenDatenLaden(DtsDaten.Lieferant.OrderBy(Function(x) x.Name).ToArray)
        Dim OpenOrderData = GetDataForHomeScreen.GetOpenOrders
        Dim OpenOrders = OpenOrderData.OpenOrders
        Dim TotalAmountOfOpenOrders = OpenOrderData.TotalAmountofOpenOrders

        Dim OpenReclamationData = GetDataForHomeScreen.GetOpenReclamations
        Dim OpenReclamations = OpenReclamationData.OpenReclamations
        Dim TotalAmountOfOpenReclamations = OpenReclamationData.TotalAmountofOpenReclamations

        Dim MissingInvoiceData = GetDataForHomeScreen.GetMissingInvoices
        Dim MissingInvoices = MissingInvoiceData.MissingInvoices
        Dim TotalAmountOfMissingInvoices = MissingInvoiceData.TotalAmountofMissingInvoices

        Dim CustomerOrderData = GetDataForHomeScreen.GetOpenCustomerOrders
        Dim OpenCustomerOrders = CustomerOrderData.OpenCustomerOrders
        Dim TotalAmountOfOpenCustomerOrders = CustomerOrderData.TotalAmountOfOpenCustomerOrders

        If TotalAmountOfOpenOrders > 0 Then DrawOpenOrders(OpenOrders, TotalAmountOfOpenOrders)
        If TotalAmountOfOpenReclamations > 0 Then DrawOpenReclamations(OpenReclamations, TotalAmountOfOpenReclamations)
        If TotalAmountOfMissingInvoices > 0 Then DrawMissingInvoices(MissingInvoices, TotalAmountOfMissingInvoices)
        If TotalAmountOfOpenCustomerOrders > 0 Then DrawOpenCustomerOrders(OpenCustomerOrders, TotalAmountOfOpenCustomerOrders)
    End Sub
    Private Sub ClearHomeScreen()
        ClearDataOnPanel(PNLOffeneBestellungen)
        ClearDataOnPanel(PNLOffeneReklamationen)
        ClearDataOnPanel(PNLOffeneKundenbestellungen)
        ClearDataOnPanel(PNLFehlendeRechnungen)
    End Sub
    Private Sub DrawOpenOrders(OpenOrders As List(Of String), TotalAmountOfOpenOrders As Integer)
        Dim xPosition As Integer
        Dim yPosition = 20
        For i = 0 To OpenOrders.Count - 1
            xPosition = CInt((Me.Width / 2 - 205 - 177 - 160) / 2)
            Dim OrderInfo() As String = Split(OpenOrders(i), "|")
            Dim LBLSupplier = CreateLabel(xPosition, yPosition, OrderInfo(0), ContentAlignment.MiddleLeft, New Drawing.Size(199, 26))
            AddHandler LBLSupplier.Click, AddressOf LBLOrder_Clicked

            xPosition += 205
            Dim LBLDeliverDuration = CreateLabel(xPosition, yPosition, OrderInfo(1), ContentAlignment.MiddleLeft, New Drawing.Size(171, 26))

            xPosition += 177
            Dim LBLArrivalDate = CreateLabel(xPosition, yPosition, OrderInfo(2), ContentAlignment.MiddleRight, New Drawing.Size(160, 26))

            PNLOffeneBestellungen.Controls.Add(LBLSupplier)
            PNLOffeneBestellungen.Controls.Add(LBLDeliverDuration)
            PNLOffeneBestellungen.Controls.Add(LBLArrivalDate)

            yPosition += 36
        Next
        LBLOffeneBestellungen.Text = $"{TotalAmountOfOpenOrders} offene Lieferungen"
    End Sub
    Private Sub LBLOrder_Clicked(sender As Object, e As EventArgs)
        Dim clickedLabel = DirectCast(sender, Label)
        If clickedLabel.Text.IsNotEmpty Then
            UcLieferungen.SetSupplierToShow(clickedLabel.Text)
            TCHaupt.SelectedTab = TPLieferungen
        End If
    End Sub
    Private Sub DrawOpenReclamations(OpenReclamations As List(Of String), TotalAmountOfOpenReclamations As Integer)
        Dim xPosition As Integer
        Dim yPosition = 20
        For i = 0 To OpenReclamations.Count - 1
            xPosition = CInt((Me.Width / 2 - 205 - 190) / 2)
            Dim ReclamationInfo() As String = Split(OpenReclamations(i), "|")
            Dim LBLSupplier = CreateLabel(xPosition, yPosition, ReclamationInfo(0), ContentAlignment.MiddleLeft, New Drawing.Size(199, 26))
            AddHandler LBLSupplier.Click, AddressOf LBLOpenReclamation_Clicked

            xPosition += 205
            Dim LBLReclaDate = CreateLabel(xPosition, yPosition, ReclamationInfo(1), ContentAlignment.MiddleRight, New Drawing.Size(190, 26))

            PNLOffeneReklamationen.Controls.Add(LBLSupplier)
            PNLOffeneReklamationen.Controls.Add(LBLReclaDate)

            yPosition += 36
        Next
        LBLOffeneReklamationen.Text = $"{TotalAmountOfOpenReclamations} offene Reklamationen"
    End Sub
    Private Sub LBLOpenReclamation_Clicked(sender As Object, e As EventArgs)
        Dim clickedLabel = DirectCast(sender, Label)
        If clickedLabel.Text.IsNotEmpty Then
            UcReklamation.CCBLieferant.UndoClear()
            UcReklamation.SetSupplierToShowByName(clickedLabel.Text)
            TCHaupt.SelectedTab = TPReklamation
        End If
    End Sub
    Private Sub DrawMissingInvoices(MissingInvoices As List(Of String), TotalAmountOfMissingInvoices As Integer)
        Dim xPosition As Integer
        Dim yPosition = 20
        For i = 0 To MissingInvoices.Count - 1
            xPosition = CInt((Me.Width / 2 - 205 - 190) / 2)
            Dim ReclamationInfo() As String = Split(MissingInvoices(i), "|")
            Dim LBLSupplier = CreateLabel(xPosition, yPosition, ReclamationInfo(0), ContentAlignment.MiddleLeft, New Drawing.Size(199, 26))
            AddHandler LBLSupplier.Click, AddressOf LBLOrder_Clicked

            xPosition += 205
            Dim LBLOrderDate = CreateLabel(xPosition, yPosition, ReclamationInfo(1), ContentAlignment.MiddleRight, New Drawing.Size(190, 26))

            PNLFehlendeRechnungen.Controls.Add(LBLSupplier)
            PNLFehlendeRechnungen.Controls.Add(LBLOrderDate)

            yPosition += 36
        Next
        LBLFehlendeRechnungen.Text = $"{TotalAmountOfMissingInvoices} fehlende Rechnungen"
    End Sub
    Private Sub DrawOpenCustomerOrders(OpenCustomerOrders As List(Of String), TotalAmountOfOpenCustomerOrders As Integer)
        Dim xPosition As Integer
        Dim yPosition = 20
        For i = 0 To OpenCustomerOrders.Count - 1
            xPosition = CInt((Me.Width / 2 - 205 - 177 - 160) / 2)
            Dim OrderInfo() As String = Split(OpenCustomerOrders(i), "|")
            Dim LBLSupplier = CreateLabel(xPosition, yPosition, OrderInfo(0), ContentAlignment.MiddleLeft, New Drawing.Size(199, 26))
            AddHandler LBLSupplier.Click, AddressOf LBLOpenCustomerOrder_Clicked

            xPosition += 205
            Dim LBLArticleName = CreateLabel(xPosition, yPosition, OrderInfo(1), ContentAlignment.MiddleLeft, New Drawing.Size(171, 26))

            xPosition += 177
            Dim LBLOrderDate = CreateLabel(xPosition, yPosition, OrderInfo(2), ContentAlignment.MiddleRight, New Drawing.Size(199, 26))

            PNLOffeneKundenbestellungen.Controls.Add(LBLSupplier)
            PNLOffeneKundenbestellungen.Controls.Add(LBLArticleName)
            PNLOffeneKundenbestellungen.Controls.Add(LBLOrderDate)

            yPosition += 36
        Next
        LBLOffeneKundenbestellungen.Text = $"{TotalAmountOfOpenCustomerOrders} offene Kundenbestellungen"
    End Sub
    Private Sub LBLOpenCustomerOrder_Clicked(sender As Object, e As EventArgs)
        Dim clickedLabel = DirectCast(sender, Label)
        If clickedLabel.Text.IsNotEmpty Then
            UcKundenbestellung.CCBLieferant.UndoClear()
            UcKundenbestellung.SetSupplierToShowByName(clickedLabel.Text)
            TCHaupt.SelectedTab = TPKundenbestellungen
        End If
    End Sub
    Private Function CreateLabel(xPosition As Integer, yPosition As Integer, LBLText As String,
                                 Alignment As ContentAlignment, LBLSize As Size) As Label
        Dim NewLBL As New System.Windows.Forms.Label
        With NewLBL
            .Location = New System.Drawing.Point(xPosition, yPosition)
            .Font = New Font("Microsoft Sans Serif", 16)
            .Name = "LBL" & LBLText
            .TextAlign = Alignment
            .Size = LBLSize
            .Text = LBLText
            .Visible = True
        End With
        Return NewLBL
    End Function
    Private Sub ClearDataOnPanel(PNLName As Panel)
        For i = PNLName.Controls.Count - 1 To 0 Step -1
            If TypeOf PNLName.Controls(i) Is Label Then
                PNLName.Controls.RemoveAt(i)
            End If
        Next
    End Sub
End Class